/* Generated by re2c 0.13.5 on Wed Sep 15 18:53:44 2010 */
#line 1 "Zend/zend_language_scanner.l"
/*
   +----------------------------------------------------------------------+
   | Zend Engine                                                          |
   +----------------------------------------------------------------------+
   | Copyright (c) 1998-2010 Zend Technologies Ltd. (http://www.zend.com) |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.00 of the Zend license,     |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.zend.com/license/2_00.txt.                                |
   | If you did not receive a copy of the Zend license and are unable to  |
   | obtain it through the world-wide-web, please send a note to          |
   | license@zend.com so we can mail you a copy immediately.              |
   +----------------------------------------------------------------------+
   | Authors: Marcus Boerger <helly@php.net>                              |
   |          Nuno Lopes <nlopess@php.net>                                |
   |          Scott MacVicar <scottmac@php.net>                           |
   | Flex version authors:                                                |
   |          Andi Gutmans <andi@zend.com>                                |
   |          Zeev Suraski <zeev@zend.com>                                |
   +----------------------------------------------------------------------+
*/

/* $Id: zend_language_scanner.c 303402 2010-09-15 16:58:11Z pajoye $ */

#if 0
# define YYDEBUG(s, c) printf("state: %d char: %c\n", s, c)
#else
# define YYDEBUG(s, c)
#endif

#include "zend_language_scanner_defs.h"

#include <errno.h>
#include "zend.h"
#include "zend_alloc.h"
#include <zend_language_parser.h>
#include "zend_compile.h"
#include "zend_language_scanner.h"
#include "zend_highlight.h"
#include "zend_constants.h"
#include "zend_variables.h"
#include "zend_operators.h"
#include "zend_API.h"
#include "zend_strtod.h"
#include "zend_exceptions.h"
#include "tsrm_virtual_cwd.h"
#include "tsrm_config_common.h"

#define YYCTYPE   unsigned char
#define YYFILL(n) { if ((YYCURSOR + n) >= (YYLIMIT + ZEND_MMAP_AHEAD)) { return 0; } }
#define YYCURSOR  SCNG(yy_cursor)
#define YYLIMIT   SCNG(yy_limit)
#define YYMARKER  SCNG(yy_marker)

#define YYGETCONDITION()  SCNG(yy_state)
#define YYSETCONDITION(s) SCNG(yy_state) = s

#define STATE(name)  yyc##name

/* emulate flex constructs */
#define BEGIN(state) YYSETCONDITION(STATE(state))
#define YYSTATE      YYGETCONDITION()
#define yytext       ((char*)SCNG(yy_text))
#define yyleng       SCNG(yy_leng)
#define yyless(x)    do { YYCURSOR = (unsigned char*)yytext + x; \
                          yyleng   = (unsigned int)x; } while(0)
#define yymore()     goto yymore_restart

/* perform sanity check. If this message is triggered you should
   increase the ZEND_MMAP_AHEAD value in the zend_streams.h file */
#define YYMAXFILL 16
#if ZEND_MMAP_AHEAD < YYMAXFILL
# error ZEND_MMAP_AHEAD should be greater than or equal to YYMAXFILL
#endif

#ifdef HAVE_STDARG_H
# include <stdarg.h>
#endif

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

/* Globals Macros */
#define SCNG	LANG_SCNG
#ifdef ZTS
ZEND_API ts_rsrc_id language_scanner_globals_id;
#else
ZEND_API zend_php_scanner_globals language_scanner_globals;
#endif

#define HANDLE_NEWLINES(s, l)													\
do {																			\
	char *p = (s), *boundary = p+(l);											\
																				\
	while (p<boundary) {														\
		if (*p == '\n' || (*p == '\r' && (*(p+1) != '\n'))) {					\
			CG(zend_lineno)++;													\
		}																		\
		p++;																	\
	}																			\
} while (0)

#define HANDLE_NEWLINE(c) \
{ \
	if (c == '\n' || c == '\r') { \
		CG(zend_lineno)++; \
	} \
}

/* To save initial string length after scanning to first variable, CG(doc_comment_len) can be reused */
#define SET_DOUBLE_QUOTES_SCANNED_LENGTH(len) CG(doc_comment_len) = (len)
#define GET_DOUBLE_QUOTES_SCANNED_LENGTH()    CG(doc_comment_len)

#define IS_LABEL_START(c) (((c) >= 'a' && (c) <= 'z') || ((c) >= 'A' && (c) <= 'Z') || (c) == '_' || (c) >= 0x7F)

#define ZEND_IS_OCT(c)  ((c)>='0' && (c)<='7')
#define ZEND_IS_HEX(c)  (((c)>='0' && (c)<='9') || ((c)>='a' && (c)<='f') || ((c)>='A' && (c)<='F'))

BEGIN_EXTERN_C()

static void _yy_push_state(int new_state TSRMLS_DC)
{
	zend_stack_push(&SCNG(state_stack), (void *) &YYGETCONDITION(), sizeof(int));
	YYSETCONDITION(new_state);
}

#define yy_push_state(state_and_tsrm) _yy_push_state(yyc##state_and_tsrm)

static void yy_pop_state(TSRMLS_D)
{
	int *stack_state;
	zend_stack_top(&SCNG(state_stack), (void **) &stack_state);
	YYSETCONDITION(*stack_state);
	zend_stack_del_top(&SCNG(state_stack));
}

static void yy_scan_buffer(char *str, unsigned int len TSRMLS_DC)
{
	YYCURSOR       = (YYCTYPE*)str;
	YYLIMIT        = YYCURSOR + len;
	if (!SCNG(yy_start)) {
		SCNG(yy_start) = YYCURSOR;
	}
}

void startup_scanner(TSRMLS_D)
{
	CG(heredoc) = NULL;
	CG(heredoc_len) = 0;
	CG(doc_comment) = NULL;
	CG(doc_comment_len) = 0;
	zend_stack_init(&SCNG(state_stack));
}

void shutdown_scanner(TSRMLS_D)
{
	if (CG(heredoc)) {
		efree(CG(heredoc));
		CG(heredoc_len)=0;
	}
	zend_stack_destroy(&SCNG(state_stack));
	RESET_DOC_COMMENT();
}

ZEND_API void zend_save_lexical_state(zend_lex_state *lex_state TSRMLS_DC)
{
	lex_state->yy_leng   = SCNG(yy_leng);
	lex_state->yy_start  = SCNG(yy_start);
	lex_state->yy_text   = SCNG(yy_text);
	lex_state->yy_cursor = SCNG(yy_cursor);
	lex_state->yy_marker = SCNG(yy_marker);
	lex_state->yy_limit  = SCNG(yy_limit);

	lex_state->state_stack = SCNG(state_stack);
	zend_stack_init(&SCNG(state_stack));

	lex_state->in = SCNG(yy_in);
	lex_state->yy_state = YYSTATE;
	lex_state->filename = zend_get_compiled_filename(TSRMLS_C);
	lex_state->lineno = CG(zend_lineno);

#ifdef ZEND_MULTIBYTE
	lex_state->script_org = SCNG(script_org);
	lex_state->script_org_size = SCNG(script_org_size);
	lex_state->script_filtered = SCNG(script_filtered);
	lex_state->script_filtered_size = SCNG(script_filtered_size);
	lex_state->input_filter = SCNG(input_filter);
	lex_state->output_filter = SCNG(output_filter);
	lex_state->script_encoding = SCNG(script_encoding);
	lex_state->internal_encoding = SCNG(internal_encoding);
#endif /* ZEND_MULTIBYTE */
}

ZEND_API void zend_restore_lexical_state(zend_lex_state *lex_state TSRMLS_DC)
{
	SCNG(yy_leng)   = lex_state->yy_leng;
	SCNG(yy_start)  = lex_state->yy_start;
	SCNG(yy_text)   = lex_state->yy_text;
	SCNG(yy_cursor) = lex_state->yy_cursor;
	SCNG(yy_marker) = lex_state->yy_marker;
	SCNG(yy_limit)  = lex_state->yy_limit;

	zend_stack_destroy(&SCNG(state_stack));
	SCNG(state_stack) = lex_state->state_stack;

	SCNG(yy_in) = lex_state->in;
	YYSETCONDITION(lex_state->yy_state);
	CG(zend_lineno) = lex_state->lineno;
	zend_restore_compiled_filename(lex_state->filename TSRMLS_CC);
#ifdef ZEND_MULTIBYTE
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
		SCNG(script_org) = NULL;
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	SCNG(script_org) = lex_state->script_org;
	SCNG(script_org_size) = lex_state->script_org_size;
	SCNG(script_filtered) = lex_state->script_filtered;
	SCNG(script_filtered_size) = lex_state->script_filtered_size;
	SCNG(input_filter) = lex_state->input_filter;
	SCNG(output_filter) = lex_state->output_filter;
	SCNG(script_encoding) = lex_state->script_encoding;
	SCNG(internal_encoding) = lex_state->internal_encoding;
#endif /* ZEND_MULTIBYTE */
}

ZEND_API void zend_destroy_file_handle(zend_file_handle *file_handle TSRMLS_DC)
{
	zend_llist_del_element(&CG(open_files), file_handle, (int (*)(void *, void *)) zend_compare_file_handles);
	/* zend_file_handle_dtor() operates on the copy, so we have to NULLify the original here */
	file_handle->opened_path = NULL;
	if (file_handle->free_filename) {
		file_handle->filename = NULL;
	}
}


ZEND_API int open_file_for_scanning(zend_file_handle *file_handle TSRMLS_DC)
{
	char *file_path = NULL, *buf;
	size_t size, offset = 0;
	
	/* The shebang line was read, get the current position to obtain the buffer start */
	if (CG(start_lineno) == 2 && file_handle->type == ZEND_HANDLE_FP && file_handle->handle.fp) {
		if ((offset = ftell(file_handle->handle.fp)) == -1) {
			offset = 0;
		}
	}

	if (zend_stream_fixup(file_handle, &buf, &size TSRMLS_CC) == FAILURE) {
		return FAILURE;
	}

	zend_llist_add_element(&CG(open_files), file_handle);
	if (file_handle->handle.stream.handle >= (void*)file_handle && file_handle->handle.stream.handle <= (void*)(file_handle+1)) {
		zend_file_handle *fh = (zend_file_handle*)zend_llist_get_last(&CG(open_files));
		size_t diff = (char*)file_handle->handle.stream.handle - (char*)file_handle;
		fh->handle.stream.handle = (void*)(((char*)fh) + diff);
		file_handle->handle.stream.handle = fh->handle.stream.handle;
	}

	/* Reset the scanner for scanning the new file */
	SCNG(yy_in) = file_handle;
	SCNG(yy_start) = NULL;

	if (size != -1) {
#ifdef ZEND_MULTIBYTE
		if (zend_multibyte_read_script((unsigned char *)buf, size TSRMLS_CC) != 0) {
			return FAILURE;
		}

		SCNG(yy_in) = NULL;

		zend_multibyte_set_filter(NULL TSRMLS_CC);

		if (!SCNG(input_filter)) {
			SCNG(script_filtered) = (unsigned char*)emalloc(SCNG(script_org_size)+1);
			memcpy(SCNG(script_filtered), SCNG(script_org), SCNG(script_org_size)+1);
			SCNG(script_filtered_size) = SCNG(script_org_size);
		} else {
			SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size) TSRMLS_CC);
		}
		SCNG(yy_start) = SCNG(script_filtered) - offset;
		yy_scan_buffer((char *)SCNG(script_filtered), SCNG(script_filtered_size) TSRMLS_CC);
#else /* !ZEND_MULTIBYTE */
		SCNG(yy_start) = buf - offset;
		yy_scan_buffer(buf, size TSRMLS_CC);
#endif /* ZEND_MULTIBYTE */
	} else {
		zend_error_noreturn(E_COMPILE_ERROR, "zend_stream_mmap() failed");
	}

	BEGIN(INITIAL);

	if (file_handle->opened_path) {
		file_path = file_handle->opened_path;
	} else {
		file_path = file_handle->filename;
	}

	zend_set_compiled_filename(file_path TSRMLS_CC);

	if (CG(start_lineno)) {
		CG(zend_lineno) = CG(start_lineno);
		CG(start_lineno) = 0;
	} else {
		CG(zend_lineno) = 1;
	}

	CG(increment_lineno) = 0;
	return SUCCESS;
}
END_EXTERN_C()


ZEND_API zend_op_array *compile_file(zend_file_handle *file_handle, int type TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = (zend_op_array *) emalloc(sizeof(zend_op_array));
	zend_op_array *original_active_op_array = CG(active_op_array);
	zend_op_array *retval=NULL;
	int compiler_result;
	zend_bool compilation_successful=0;
	znode retval_znode;
	zend_bool original_in_compilation = CG(in_compilation);

	retval_znode.op_type = IS_CONST;
	retval_znode.u.constant.type = IS_LONG;
	retval_znode.u.constant.value.lval = 1;
	Z_UNSET_ISREF(retval_znode.u.constant);
	Z_SET_REFCOUNT(retval_znode.u.constant, 1);

	zend_save_lexical_state(&original_lex_state TSRMLS_CC);

	retval = op_array; /* success oriented */

	if (open_file_for_scanning(file_handle TSRMLS_CC)==FAILURE) {
		if (type==ZEND_REQUIRE) {
			zend_message_dispatcher(ZMSG_FAILED_REQUIRE_FOPEN, file_handle->filename TSRMLS_CC);
			zend_bailout();
		} else {
			zend_message_dispatcher(ZMSG_FAILED_INCLUDE_FOPEN, file_handle->filename TSRMLS_CC);
		}
		compilation_successful=0;
	} else {
		init_op_array(op_array, ZEND_USER_FUNCTION, INITIAL_OP_ARRAY_SIZE TSRMLS_CC);
		CG(in_compilation) = 1;
		CG(active_op_array) = op_array;
		zend_init_compiler_context(TSRMLS_C);
		compiler_result = zendparse(TSRMLS_C);
		zend_do_return(&retval_znode, 0 TSRMLS_CC);
		CG(in_compilation) = original_in_compilation;
		if (compiler_result==1) { /* parser error */
			zend_bailout();
		}
		compilation_successful=1;
	}

	if (retval) {
		CG(active_op_array) = original_active_op_array;
		if (compilation_successful) {
			pass_two(op_array TSRMLS_CC);
			zend_release_labels(TSRMLS_C);
		} else {
			efree(op_array);
			retval = NULL;
		}
	}
	zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	return retval;
}


zend_op_array *compile_filename(int type, zval *filename TSRMLS_DC)
{
	zend_file_handle file_handle;
	zval tmp;
	zend_op_array *retval;
	char *opened_path = NULL;

	if (filename->type != IS_STRING) {
		tmp = *filename;
		zval_copy_ctor(&tmp);
		convert_to_string(&tmp);
		filename = &tmp;
	}
	file_handle.filename = filename->value.str.val;
	file_handle.free_filename = 0;
	file_handle.type = ZEND_HANDLE_FILENAME;
	file_handle.opened_path = NULL;
	file_handle.handle.fp = NULL;

	retval = zend_compile_file(&file_handle, type TSRMLS_CC);
	if (retval && file_handle.handle.stream.handle) {
		int dummy = 1;

		if (!file_handle.opened_path) {
			file_handle.opened_path = opened_path = estrndup(filename->value.str.val, filename->value.str.len);
		}

		zend_hash_add(&EG(included_files), file_handle.opened_path, strlen(file_handle.opened_path)+1, (void *)&dummy, sizeof(int), NULL);

		if (opened_path) {
			efree(opened_path);
		}
	}
	zend_destroy_file_handle(&file_handle TSRMLS_CC);

	if (filename==&tmp) {
		zval_dtor(&tmp);
	}
	return retval;
}

ZEND_API int zend_prepare_string_for_scanning(zval *str, char *filename TSRMLS_DC)
{
	/* enforce two trailing NULLs for flex... */
	if (IS_INTERNED(str->value.str.val)) {
		char *tmp = safe_emalloc(1, str->value.str.len, ZEND_MMAP_AHEAD);
		memcpy(tmp, str->value.str.val, str->value.str.len + ZEND_MMAP_AHEAD);
		str->value.str.val = tmp;
	} else {
		str->value.str.val = safe_erealloc(str->value.str.val, 1, str->value.str.len, ZEND_MMAP_AHEAD);
	}

	memset(str->value.str.val + str->value.str.len, 0, ZEND_MMAP_AHEAD);

	SCNG(yy_in)=NULL;
	SCNG(yy_start) = NULL;

#ifdef ZEND_MULTIBYTE
	SCNG(script_org) = (unsigned char *)estrdup(str->value.str.val);
	SCNG(script_org_size) = str->value.str.len;

	zend_multibyte_set_filter(CG(internal_encoding) TSRMLS_CC);

	if (!SCNG(input_filter)) {
		SCNG(script_filtered) = (unsigned char*)emalloc(SCNG(script_org_size)+1);
		memcpy(SCNG(script_filtered), SCNG(script_org), SCNG(script_org_size)+1);
		SCNG(script_filtered_size) = SCNG(script_org_size);
	} else {
		SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size) TSRMLS_CC);
	}

	yy_scan_buffer((char *)SCNG(script_filtered), SCNG(script_filtered_size) TSRMLS_CC);	
#else /* !ZEND_MULTIBYTE */
	yy_scan_buffer(str->value.str.val, str->value.str.len TSRMLS_CC);
#endif /* ZEND_MULTIBYTE */

	zend_set_compiled_filename(filename TSRMLS_CC);
	CG(zend_lineno) = 1;
	CG(increment_lineno) = 0;
	return SUCCESS;
}


ZEND_API size_t zend_get_scanned_file_offset(TSRMLS_D)
{
	size_t offset = SCNG(yy_cursor) - SCNG(yy_start);
#ifdef ZEND_MULTIBYTE
	if (SCNG(input_filter)) {
		size_t original_offset = offset, length = 0; do {
			unsigned char *p = NULL;
			SCNG(input_filter)(&p, &length, SCNG(script_org), offset TSRMLS_CC);
			if (!p) {
				break;
			}
			efree(p);
			if (length > original_offset) {
				offset--;
			} else if (length < original_offset) {
				offset++;
			}
		} while (original_offset != length);
	}
#endif
	return offset;
}


zend_op_array *compile_string(zval *source_string, char *filename TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = (zend_op_array *) emalloc(sizeof(zend_op_array));
	zend_op_array *original_active_op_array = CG(active_op_array);
	zend_op_array *retval;
	zval tmp;
	int compiler_result;
	zend_bool original_in_compilation = CG(in_compilation);

	if (source_string->value.str.len==0) {
		efree(op_array);
		return NULL;
	}

	CG(in_compilation) = 1;

	tmp = *source_string;
	zval_copy_ctor(&tmp);
	convert_to_string(&tmp);
	source_string = &tmp;

	zend_save_lexical_state(&original_lex_state TSRMLS_CC);
	if (zend_prepare_string_for_scanning(source_string, filename TSRMLS_CC)==FAILURE) {
		efree(op_array);
		retval = NULL;
	} else {
		zend_bool orig_interactive = CG(interactive);

		CG(interactive) = 0;
		init_op_array(op_array, ZEND_EVAL_CODE, INITIAL_OP_ARRAY_SIZE TSRMLS_CC);
		CG(interactive) = orig_interactive;
		CG(active_op_array) = op_array;
		zend_init_compiler_context(TSRMLS_C);
		BEGIN(ST_IN_SCRIPTING);
		compiler_result = zendparse(TSRMLS_C);

#ifdef ZEND_MULTIBYTE
		if (SCNG(script_org)) {
			efree(SCNG(script_org));
			SCNG(script_org) = NULL;
		}
		if (SCNG(script_filtered)) {
			efree(SCNG(script_filtered));
			SCNG(script_filtered) = NULL;
		}
#endif /* ZEND_MULTIBYTE */

		if (compiler_result==1) {
			CG(active_op_array) = original_active_op_array;
			CG(unclean_shutdown)=1;
			retval = NULL;
		} else {
			zend_do_return(NULL, 0 TSRMLS_CC);
			CG(active_op_array) = original_active_op_array;
			pass_two(op_array TSRMLS_CC);
			zend_release_labels(TSRMLS_C);
			retval = op_array;
		}
	}
	zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	zval_dtor(&tmp);
	CG(in_compilation) = original_in_compilation;
	return retval;
}


BEGIN_EXTERN_C()
int highlight_file(char *filename, zend_syntax_highlighter_ini *syntax_highlighter_ini TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zend_file_handle file_handle;

	file_handle.type = ZEND_HANDLE_FILENAME;
	file_handle.filename = filename;
	file_handle.free_filename = 0;
	file_handle.opened_path = NULL;
	zend_save_lexical_state(&original_lex_state TSRMLS_CC);
	if (open_file_for_scanning(&file_handle TSRMLS_CC)==FAILURE) {
		zend_message_dispatcher(ZMSG_FAILED_HIGHLIGHT_FOPEN, filename TSRMLS_CC);
		zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
		return FAILURE;
	}
	zend_highlight(syntax_highlighter_ini TSRMLS_CC);
#ifdef ZEND_MULTIBYTE
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
		SCNG(script_org) = NULL;
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
#endif /* ZEND_MULTIBYTE */
	zend_destroy_file_handle(&file_handle TSRMLS_CC);
	zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	return SUCCESS;
}

int highlight_string(zval *str, zend_syntax_highlighter_ini *syntax_highlighter_ini, char *str_name TSRMLS_DC)
{
	zend_lex_state original_lex_state;
	zval tmp = *str;

	str = &tmp;
	zval_copy_ctor(str);
	zend_save_lexical_state(&original_lex_state TSRMLS_CC);
	if (zend_prepare_string_for_scanning(str, str_name TSRMLS_CC)==FAILURE) {
		zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
		return FAILURE;
	}
	BEGIN(INITIAL);
	zend_highlight(syntax_highlighter_ini TSRMLS_CC);
#ifdef ZEND_MULTIBYTE
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
		SCNG(script_org) = NULL;
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
#endif /* ZEND_MULTIBYTE */
	zend_restore_lexical_state(&original_lex_state TSRMLS_CC);
	zval_dtor(str);
	return SUCCESS;
}
END_EXTERN_C()

#ifdef ZEND_MULTIBYTE

BEGIN_EXTERN_C()
ZEND_API void zend_multibyte_yyinput_again(zend_encoding_filter old_input_filter, zend_encoding *old_encoding TSRMLS_DC)
{
	size_t original_offset, offset, free_flag, new_len, length;
	unsigned char *p;

	/* calculate current position */
	offset = original_offset = YYCURSOR - SCNG(yy_start);
	if (old_input_filter && offset > 0) {
		zend_encoding *new_encoding = SCNG(script_encoding);
		zend_encoding_filter new_filter = SCNG(input_filter);
		SCNG(script_encoding) = old_encoding;
		SCNG(input_filter) = old_input_filter;
		offset = zend_get_scanned_file_offset(TSRMLS_C);
		SCNG(script_encoding) = new_encoding;
		SCNG(input_filter) = new_filter;
	}

	/* convert and set */
	if (!SCNG(input_filter)) {
		length = SCNG(script_org_size) - offset;
		p = SCNG(script_org) + offset;
		free_flag = 0;
	} else {
		SCNG(input_filter)(&p, &length, SCNG(script_org) + offset, SCNG(script_org_size) - offset TSRMLS_CC);
		free_flag = 1;
	}

	new_len = original_offset + length;

	if (new_len > YYLIMIT - SCNG(yy_start)) {
		unsigned char *new_yy_start = erealloc(SCNG(yy_start), new_len);
		SCNG(yy_cursor) = new_yy_start + (SCNG(yy_cursor) - SCNG(yy_start));
		SCNG(yy_marker) = new_yy_start + (SCNG(yy_marker) - SCNG(yy_start));
		SCNG(yy_text) = new_yy_start + (SCNG(yy_text) - SCNG(yy_start));
		SCNG(yy_start) = new_yy_start;
		SCNG(script_filtered) = new_yy_start;
		SCNG(script_filtered_size) = new_len;
	}

	SCNG(yy_limit) = SCNG(yy_start) + new_len;
	memmove(SCNG(yy_start) + original_offset, p, length);

	if (free_flag) {
		efree(p);
	}
}


ZEND_API int zend_multibyte_yyinput(zend_file_handle *file_handle, char *buf, size_t len TSRMLS_DC)
{
	size_t n;

	if (CG(interactive) == 0) {
		if (zend_stream_fixup(file_handle, &buf, &len TSRMLS_CC) == FAILURE) {
			return FAILURE;
		}
		n = len;
		return n;
	}

	/* interactive */
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
	}
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
	}
	SCNG(script_org) = NULL;
	SCNG(script_org_size) = 0;

	/* TODO: support widechars */
	if (zend_stream_fixup(file_handle, &buf, &len TSRMLS_CC) == FAILURE) {
		return FAILURE;
	}
	n = len;

	SCNG(script_org_size) = n;
	SCNG(script_org) = (unsigned char*)emalloc(SCNG(script_org_size) + 1);
	memcpy(SCNG(script_org), buf, n);

	return n;
}


ZEND_API int zend_multibyte_read_script(unsigned char *buf, size_t n TSRMLS_DC)
{
	if (SCNG(script_org)) {
		efree(SCNG(script_org));
		SCNG(script_org) = NULL;
	}
	SCNG(script_org_size) = n;	
	
	SCNG(script_org) = (unsigned char*)emalloc(SCNG(script_org_size) + 1);
	memcpy(SCNG(script_org), buf, n);
	*(SCNG(script_org)+SCNG(script_org_size)) = '\0';

	return 0;
}


# define zend_copy_value(zendlval, yytext, yyleng) \
	if (SCNG(output_filter)) { \
		size_t sz = 0; \
		SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)yytext, (size_t)yyleng TSRMLS_CC); \
		zendlval->value.str.len = sz; \
	} else { \
		zendlval->value.str.val = (char *) estrndup(yytext, yyleng); \
		zendlval->value.str.len = yyleng; \
	}
#else /* ZEND_MULTIBYTE */
# define zend_copy_value(zendlval, yytext, yyleng) \
	zendlval->value.str.val = (char *)estrndup(yytext, yyleng); \
	zendlval->value.str.len = yyleng;
#endif /* ZEND_MULTIBYTE */

static void zend_scan_escape_string(zval *zendlval, char *str, int len, char quote_type TSRMLS_DC)
{
	register char *s, *t;
	char *end;

	ZVAL_STRINGL(zendlval, str, len, 1);

	/* convert escape sequences */
	s = t = zendlval->value.str.val;
	end = s+zendlval->value.str.len;
	while (s<end) {
		if (*s=='\\') {
			s++;
			if (s >= end) {
				*t++ = '\\';
				break;
			}

			switch(*s) {
				case 'n':
					*t++ = '\n';
					zendlval->value.str.len--;
					break;
				case 'r':
					*t++ = '\r';
					zendlval->value.str.len--;
					break;
				case 't':
					*t++ = '\t';
					zendlval->value.str.len--;
					break;
				case 'f':
					*t++ = '\f';
					zendlval->value.str.len--;
					break;
				case 'v':
					*t++ = '\v';
					zendlval->value.str.len--;
					break;
				case '"':
				case '`':
					if (*s != quote_type) {
						*t++ = '\\';
						*t++ = *s;
						break;
					}
				case '\\':
				case '$':
					*t++ = *s;
					zendlval->value.str.len--;
					break;
				case 'x':
				case 'X':
					if (ZEND_IS_HEX(*(s+1))) {
						char hex_buf[3] = { 0, 0, 0 };

						zendlval->value.str.len--; /* for the 'x' */

						hex_buf[0] = *(++s);
						zendlval->value.str.len--;
						if (ZEND_IS_HEX(*(s+1))) {
							hex_buf[1] = *(++s);
							zendlval->value.str.len--;
						}
						*t++ = (char) strtol(hex_buf, NULL, 16);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
				default:
					/* check for an octal */
					if (ZEND_IS_OCT(*s)) {
						char octal_buf[4] = { 0, 0, 0, 0 };

						octal_buf[0] = *s;
						zendlval->value.str.len--;
						if (ZEND_IS_OCT(*(s+1))) {
							octal_buf[1] = *(++s);
							zendlval->value.str.len--;
							if (ZEND_IS_OCT(*(s+1))) {
								octal_buf[2] = *(++s);
								zendlval->value.str.len--;
							}
						}
						*t++ = (char) strtol(octal_buf, NULL, 8);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
			}
		} else {
			*t++ = *s;
		}

		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;
#ifdef ZEND_MULTIBYTE
	if (SCNG(output_filter)) {
		size_t sz = 0;
		s = zendlval->value.str.val;
		SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)s, (size_t)zendlval->value.str.len TSRMLS_CC);
		zendlval->value.str.len = sz;
		efree(s);
	}
#endif /* ZEND_MULTIBYTE */
}


int lex_scan(zval *zendlval TSRMLS_DC)
{
restart:
	SCNG(yy_text) = YYCURSOR;

yymore_restart:


#line 858 "Zend/zend_language_scanner.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	if (YYGETCONDITION() < 5) {
		if (YYGETCONDITION() < 2) {
			if (YYGETCONDITION() < 1) {
				goto yyc_ST_IN_SCRIPTING;
			} else {
				goto yyc_ST_LOOKING_FOR_PROPERTY;
			}
		} else {
			if (YYGETCONDITION() < 3) {
				goto yyc_ST_BACKQUOTE;
			} else {
				if (YYGETCONDITION() < 4) {
					goto yyc_ST_DOUBLE_QUOTES;
				} else {
					goto yyc_ST_HEREDOC;
				}
			}
		}
	} else {
		if (YYGETCONDITION() < 7) {
			if (YYGETCONDITION() < 6) {
				goto yyc_ST_LOOKING_FOR_VARNAME;
			} else {
				goto yyc_ST_VAR_OFFSET;
			}
		} else {
			if (YYGETCONDITION() < 8) {
				goto yyc_INITIAL;
			} else {
				if (YYGETCONDITION() < 9) {
					goto yyc_ST_END_HEREDOC;
				} else {
					goto yyc_ST_NOWDOC;
				}
			}
		}
	}
/* *********************************** */
yyc_INITIAL:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128,   0,   0, 128,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
		};

		YYDEBUG(0, *YYCURSOR);
		YYFILL(8);
		yych = *YYCURSOR;
		if (yych != '<') goto yy4;
		YYDEBUG(2, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '?') {
			if (yych == '%') goto yy7;
			if (yych >= '?') goto yy5;
		} else {
			if (yych <= 'S') {
				if (yych >= 'S') goto yy9;
			} else {
				if (yych == 's') goto yy9;
			}
		}
yy3:
		YYDEBUG(3, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1646 "Zend/zend_language_scanner.l"
		{
	if (YYCURSOR > YYLIMIT) {
		return 0;
	}

inline_char_handler:

	while (1) {
		YYCTYPE *ptr = memchr(YYCURSOR, '<', YYLIMIT - YYCURSOR);

		YYCURSOR = ptr ? ptr + 1 : YYLIMIT;

		if (YYCURSOR < YYLIMIT) {
			switch (*YYCURSOR) {
				case '?':
					if (CG(short_tags) || !strncasecmp(YYCURSOR + 1, "php", 3)) { /* Assume [ \t\n\r] follows "php" */
						break;
					}
					continue;
				case '%':
					if (CG(asp_tags)) {
						break;
					}
					continue;
				case 's':
				case 'S':
					/* Probably NOT an opening PHP <script> tag, so don't end the HTML chunk yet
					 * If it is, the PHP <script> tag rule checks for any HTML scanned before it */
					YYCURSOR--;
					yymore();
				default:
					continue;
			}

			YYCURSOR--;
		}

		break;
	}

inline_html:
	yyleng = YYCURSOR - SCNG(yy_text);

#ifdef ZEND_MULTIBYTE
	if (SCNG(output_filter)) {
		int readsize;
		size_t sz = 0;
		readsize = SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)yytext, (size_t)yyleng TSRMLS_CC);
		zendlval->value.str.len = sz;
		if (readsize < yyleng) {
			yyless(readsize);
		}
	} else {
	  zendlval->value.str.val = (char *) estrndup(yytext, yyleng);
	  zendlval->value.str.len = yyleng;
	}
#else /* !ZEND_MULTIBYTE */
	zendlval->value.str.val = (char *) estrndup(yytext, yyleng);
 	zendlval->value.str.len = yyleng;
#endif
	zendlval->type = IS_STRING;
	HANDLE_NEWLINES(yytext, yyleng);
	return T_INLINE_HTML;
}
#line 1022 "Zend/zend_language_scanner.c"
yy4:
		YYDEBUG(4, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy3;
yy5:
		YYDEBUG(5, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == '=') goto yy45;
		} else {
			if (yych <= 'P') goto yy47;
			if (yych == 'p') goto yy47;
		}
yy6:
		YYDEBUG(6, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1634 "Zend/zend_language_scanner.l"
		{
	if (CG(short_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG;
	} else {
		goto inline_char_handler;
	}
}
#line 1052 "Zend/zend_language_scanner.c"
yy7:
		YYDEBUG(7, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy43;
		YYDEBUG(8, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1611 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG;
	} else {
		goto inline_char_handler;
	}
}
#line 1071 "Zend/zend_language_scanner.c"
yy9:
		YYDEBUG(9, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy11;
		if (yych == 'c') goto yy11;
yy10:
		YYDEBUG(10, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 0) {
			goto yy3;
		} else {
			goto yy6;
		}
yy11:
		YYDEBUG(11, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy12;
		if (yych != 'r') goto yy10;
yy12:
		YYDEBUG(12, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy13;
		if (yych != 'i') goto yy10;
yy13:
		YYDEBUG(13, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy14;
		if (yych != 'p') goto yy10;
yy14:
		YYDEBUG(14, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy15;
		if (yych != 't') goto yy10;
yy15:
		YYDEBUG(15, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy10;
		if (yych == 'l') goto yy10;
		goto yy17;
yy16:
		YYDEBUG(16, *YYCURSOR);
		++YYCURSOR;
		YYFILL(8);
		yych = *YYCURSOR;
yy17:
		YYDEBUG(17, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy16;
		}
		if (yych == 'L') goto yy18;
		if (yych != 'l') goto yy10;
yy18:
		YYDEBUG(18, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy19;
		if (yych != 'a') goto yy10;
yy19:
		YYDEBUG(19, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy20;
		if (yych != 'n') goto yy10;
yy20:
		YYDEBUG(20, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy21;
		if (yych != 'g') goto yy10;
yy21:
		YYDEBUG(21, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy22;
		if (yych != 'u') goto yy10;
yy22:
		YYDEBUG(22, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy23;
		if (yych != 'a') goto yy10;
yy23:
		YYDEBUG(23, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy24;
		if (yych != 'g') goto yy10;
yy24:
		YYDEBUG(24, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy25;
		if (yych != 'e') goto yy10;
yy25:
		YYDEBUG(25, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(26, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy10;
			if (yych <= '\n') goto yy25;
			if (yych <= '\f') goto yy10;
			goto yy25;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy10;
				goto yy25;
			} else {
				if (yych != '=') goto yy10;
			}
		}
yy27:
		YYDEBUG(27, *YYCURSOR);
		++YYCURSOR;
		YYFILL(5);
		yych = *YYCURSOR;
		YYDEBUG(28, *YYCURSOR);
		if (yych <= '!') {
			if (yych <= '\f') {
				if (yych <= 0x08) goto yy10;
				if (yych <= '\n') goto yy27;
				goto yy10;
			} else {
				if (yych <= '\r') goto yy27;
				if (yych == ' ') goto yy27;
				goto yy10;
			}
		} else {
			if (yych <= 'O') {
				if (yych <= '"') goto yy30;
				if (yych == '\'') goto yy31;
				goto yy10;
			} else {
				if (yych <= 'P') goto yy29;
				if (yych != 'p') goto yy10;
			}
		}
yy29:
		YYDEBUG(29, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy42;
		if (yych == 'h') goto yy42;
		goto yy10;
yy30:
		YYDEBUG(30, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy39;
		if (yych == 'p') goto yy39;
		goto yy10;
yy31:
		YYDEBUG(31, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy32;
		if (yych != 'p') goto yy10;
yy32:
		YYDEBUG(32, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy33;
		if (yych != 'h') goto yy10;
yy33:
		YYDEBUG(33, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy34;
		if (yych != 'p') goto yy10;
yy34:
		YYDEBUG(34, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '\'') goto yy10;
yy35:
		YYDEBUG(35, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(36, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy10;
			if (yych <= '\n') goto yy35;
			if (yych <= '\f') goto yy10;
			goto yy35;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy10;
				goto yy35;
			} else {
				if (yych != '>') goto yy10;
			}
		}
		YYDEBUG(37, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(38, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1567 "Zend/zend_language_scanner.l"
		{
	YYCTYPE *bracket = zend_memrchr(yytext, '<', yyleng - (sizeof("script language=php>") - 1));

	if (bracket != SCNG(yy_text)) {
		/* Handle previously scanned HTML, as possible <script> tags found are assumed to not be PHP's */
		YYCURSOR = bracket;
		goto inline_html;
	}

	HANDLE_NEWLINES(yytext, yyleng);
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	BEGIN(ST_IN_SCRIPTING);
	return T_OPEN_TAG;
}
#line 1274 "Zend/zend_language_scanner.c"
yy39:
		YYDEBUG(39, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy40;
		if (yych != 'h') goto yy10;
yy40:
		YYDEBUG(40, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy41;
		if (yych != 'p') goto yy10;
yy41:
		YYDEBUG(41, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '"') goto yy35;
		goto yy10;
yy42:
		YYDEBUG(42, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy35;
		if (yych == 'p') goto yy35;
		goto yy10;
yy43:
		YYDEBUG(43, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(44, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1585 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG_WITH_ECHO;
	} else {
		goto inline_char_handler;
	}
}
#line 1313 "Zend/zend_language_scanner.c"
yy45:
		YYDEBUG(45, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(46, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1598 "Zend/zend_language_scanner.l"
		{
	if (CG(short_tags)) {
		zendlval->value.str.val = yytext; /* no copying - intentional */
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		BEGIN(ST_IN_SCRIPTING);
		return T_OPEN_TAG_WITH_ECHO;
	} else {
		goto inline_char_handler;
	}
}
#line 1331 "Zend/zend_language_scanner.c"
yy47:
		YYDEBUG(47, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy48;
		if (yych != 'h') goto yy10;
yy48:
		YYDEBUG(48, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy49;
		if (yych != 'p') goto yy10;
yy49:
		YYDEBUG(49, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy10;
			if (yych >= '\v') goto yy10;
		} else {
			if (yych <= '\r') goto yy52;
			if (yych != ' ') goto yy10;
		}
yy50:
		YYDEBUG(50, *YYCURSOR);
		++YYCURSOR;
yy51:
		YYDEBUG(51, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1624 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	HANDLE_NEWLINE(yytext[yyleng-1]);
	BEGIN(ST_IN_SCRIPTING);
	return T_OPEN_TAG;
}
#line 1367 "Zend/zend_language_scanner.c"
yy52:
		YYDEBUG(52, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy50;
		goto yy51;
	}
/* *********************************** */
yyc_ST_BACKQUOTE:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(53, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych != '$') goto yy60;
		} else {
			if (yych <= '`') goto yy58;
			if (yych == '{') goto yy57;
			goto yy60;
		}
		YYDEBUG(55, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy56;
			if (yych <= 'Z') goto yy63;
			if (yych >= '_') goto yy63;
		} else {
			if (yych <= 'z') {
				if (yych >= 'a') goto yy63;
			} else {
				if (yych <= '{') goto yy66;
				if (yych >= 0x7F) goto yy63;
			}
		}
yy56:
		YYDEBUG(56, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2104 "Zend/zend_language_scanner.l"
		{
	if (YYCURSOR > YYLIMIT) {
		return 0;
	}
	if (yytext[0] == '\\' && YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	}

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '`':
				break;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				/* fall through */
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

	yyleng = YYCURSOR - SCNG(yy_text);

	zend_scan_escape_string(zendlval, yytext, yyleng, '`' TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 1479 "Zend/zend_language_scanner.c"
yy57:
		YYDEBUG(57, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy61;
		goto yy56;
yy58:
		YYDEBUG(58, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(59, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2048 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_IN_SCRIPTING);
	return '`';
}
#line 1495 "Zend/zend_language_scanner.c"
yy60:
		YYDEBUG(60, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy56;
yy61:
		YYDEBUG(61, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(62, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2035 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = (long) '{';
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	yyless(1);
	return T_CURLY_OPEN;
}
#line 1512 "Zend/zend_language_scanner.c"
yy63:
		YYDEBUG(63, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(64, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy63;
		}
		if (yych == '-') goto yy68;
		if (yych == '[') goto yy70;
yy65:
		YYDEBUG(65, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1733 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1534 "Zend/zend_language_scanner.c"
yy66:
		YYDEBUG(66, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(67, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1360 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME TSRMLS_CC);
	return T_DOLLAR_OPEN_CURLY_BRACES;
}
#line 1545 "Zend/zend_language_scanner.c"
yy68:
		YYDEBUG(68, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy72;
yy69:
		YYDEBUG(69, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy65;
yy70:
		YYDEBUG(70, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(71, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1725 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1567 "Zend/zend_language_scanner.c"
yy72:
		YYDEBUG(72, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy69;
			if (yych <= 'Z') goto yy73;
			if (yych <= '^') goto yy69;
		} else {
			if (yych <= '`') goto yy69;
			if (yych <= 'z') goto yy73;
			if (yych <= '~') goto yy69;
		}
yy73:
		YYDEBUG(73, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(74, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1715 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1593 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_DOUBLE_QUOTES:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(75, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '#') {
			if (yych == '"') goto yy80;
			goto yy82;
		} else {
			if (yych <= '$') goto yy77;
			if (yych == '{') goto yy79;
			goto yy82;
		}
yy77:
		YYDEBUG(77, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy78;
			if (yych <= 'Z') goto yy85;
			if (yych >= '_') goto yy85;
		} else {
			if (yych <= 'z') {
				if (yych >= 'a') goto yy85;
			} else {
				if (yych <= '{') goto yy88;
				if (yych >= 0x7F) goto yy85;
			}
		}
yy78:
		YYDEBUG(78, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2054 "Zend/zend_language_scanner.l"
		{
	if (GET_DOUBLE_QUOTES_SCANNED_LENGTH()) {
		YYCURSOR += GET_DOUBLE_QUOTES_SCANNED_LENGTH() - 1;
		SET_DOUBLE_QUOTES_SCANNED_LENGTH(0);

		goto double_quotes_scan_done;
	}

	if (YYCURSOR > YYLIMIT) {
		return 0;
	}
	if (yytext[0] == '\\' && YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	}

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '"':
				break;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				/* fall through */
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

double_quotes_scan_done:
	yyleng = YYCURSOR - SCNG(yy_text);

	zend_scan_escape_string(zendlval, yytext, yyleng, '"' TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 1710 "Zend/zend_language_scanner.c"
yy79:
		YYDEBUG(79, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy83;
		goto yy78;
yy80:
		YYDEBUG(80, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(81, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2043 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_IN_SCRIPTING);
	return '"';
}
#line 1726 "Zend/zend_language_scanner.c"
yy82:
		YYDEBUG(82, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy78;
yy83:
		YYDEBUG(83, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(84, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2035 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = (long) '{';
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	yyless(1);
	return T_CURLY_OPEN;
}
#line 1743 "Zend/zend_language_scanner.c"
yy85:
		YYDEBUG(85, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(86, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy85;
		}
		if (yych == '-') goto yy90;
		if (yych == '[') goto yy92;
yy87:
		YYDEBUG(87, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1733 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1765 "Zend/zend_language_scanner.c"
yy88:
		YYDEBUG(88, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(89, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1360 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME TSRMLS_CC);
	return T_DOLLAR_OPEN_CURLY_BRACES;
}
#line 1776 "Zend/zend_language_scanner.c"
yy90:
		YYDEBUG(90, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy94;
yy91:
		YYDEBUG(91, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy87;
yy92:
		YYDEBUG(92, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(93, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1725 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1798 "Zend/zend_language_scanner.c"
yy94:
		YYDEBUG(94, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy91;
			if (yych <= 'Z') goto yy95;
			if (yych <= '^') goto yy91;
		} else {
			if (yych <= '`') goto yy91;
			if (yych <= 'z') goto yy95;
			if (yych <= '~') goto yy91;
		}
yy95:
		YYDEBUG(95, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(96, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1715 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 1824 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_END_HEREDOC:
	YYDEBUG(97, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	YYDEBUG(99, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(100, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2022 "Zend/zend_language_scanner.l"
	{
	YYCURSOR += CG(heredoc_len) - 1;
	yyleng = CG(heredoc_len);

	Z_STRVAL_P(zendlval) = CG(heredoc);
	Z_STRLEN_P(zendlval) = CG(heredoc_len);
	CG(heredoc) = NULL;
	CG(heredoc_len) = 0;
	BEGIN(ST_IN_SCRIPTING);
	return T_END_HEREDOC;
}
#line 1847 "Zend/zend_language_scanner.c"
/* *********************************** */
yyc_ST_HEREDOC:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(101, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych == '$') goto yy103;
		if (yych == '{') goto yy105;
		goto yy106;
yy103:
		YYDEBUG(103, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy104;
			if (yych <= 'Z') goto yy109;
			if (yych >= '_') goto yy109;
		} else {
			if (yych <= 'z') {
				if (yych >= 'a') goto yy109;
			} else {
				if (yych <= '{') goto yy112;
				if (yych >= 0x7F) goto yy109;
			}
		}
yy104:
		YYDEBUG(104, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2146 "Zend/zend_language_scanner.l"
		{
	int newline = 0;

	if (YYCURSOR > YYLIMIT) {
		return 0;
	}

	YYCURSOR--;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
				if (*YYCURSOR == '\n') {
					YYCURSOR++;
				}
				/* fall through */
			case '\n':
				/* Check for ending label on the next line */
				if (IS_LABEL_START(*YYCURSOR) && CG(heredoc_len) < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, CG(heredoc), CG(heredoc_len))) {
					YYCTYPE *end = YYCURSOR + CG(heredoc_len);

					if (*end == ';') {
						end++;
					}

					if (*end == '\n' || *end == '\r') {
						/* newline before label will be subtracted from returned text, but
						 * yyleng/yytext will include it, for zend_highlight/strip, tokenizer, etc. */
						if (YYCURSOR[-2] == '\r' && YYCURSOR[-1] == '\n') {
							newline = 2; /* Windows newline */
						} else {
							newline = 1;
						}

						CG(increment_lineno) = 1; /* For newline before label */
						BEGIN(ST_END_HEREDOC);

						goto heredoc_scan_done;
					}
				}
				continue;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT && *YYCURSOR != '\n' && *YYCURSOR != '\r') {
					YYCURSOR++;
				}
				/* fall through */
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

heredoc_scan_done:
	yyleng = YYCURSOR - SCNG(yy_text);

	zend_scan_escape_string(zendlval, yytext, yyleng - newline, 0 TSRMLS_CC);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 1980 "Zend/zend_language_scanner.c"
yy105:
		YYDEBUG(105, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy107;
		goto yy104;
yy106:
		YYDEBUG(106, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy104;
yy107:
		YYDEBUG(107, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(108, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2035 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = (long) '{';
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	yyless(1);
	return T_CURLY_OPEN;
}
#line 2002 "Zend/zend_language_scanner.c"
yy109:
		YYDEBUG(109, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(110, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy109;
		}
		if (yych == '-') goto yy114;
		if (yych == '[') goto yy116;
yy111:
		YYDEBUG(111, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1733 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 2024 "Zend/zend_language_scanner.c"
yy112:
		YYDEBUG(112, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(113, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1360 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME TSRMLS_CC);
	return T_DOLLAR_OPEN_CURLY_BRACES;
}
#line 2035 "Zend/zend_language_scanner.c"
yy114:
		YYDEBUG(114, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy118;
yy115:
		YYDEBUG(115, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy111;
yy116:
		YYDEBUG(116, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(117, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1725 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 2057 "Zend/zend_language_scanner.c"
yy118:
		YYDEBUG(118, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy115;
			if (yych <= 'Z') goto yy119;
			if (yych <= '^') goto yy115;
		} else {
			if (yych <= '`') goto yy115;
			if (yych <= 'z') goto yy119;
			if (yych <= '~') goto yy115;
		}
yy119:
		YYDEBUG(119, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(120, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1715 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 2083 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_IN_SCRIPTING:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 224, 160,   0,   0, 160,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			224,   0,   0,   0,   0,   0, 128,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			 28,  28,  28,  28,  28,  28,  28,  28, 
			 28,  28,   0,   0,   0,   0,   0,   0, 
			  0,  20,  20,  20,  20,  20,  20,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   0,   0,   0,   0,   4, 
			  0,  20,  20,  20,  20,  20,  20,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   0,   0,   0,   0,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
			  4,   4,   4,   4,   4,   4,   4,   4, 
		};
		YYDEBUG(121, *YYCURSOR);
		YYFILL(16);
		yych = *YYCURSOR;
		YYDEBUG(-1, yych);
		switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x1F:	goto yy183;
		case '\t':
		case '\n':
		case '\r':
		case ' ':	goto yy139;
		case '!':	goto yy153;
		case '"':	goto yy179;
		case '#':	goto yy175;
		case '$':	goto yy164;
		case '%':	goto yy159;
		case '&':	goto yy160;
		case '\'':	goto yy177;
		case '(':	goto yy146;
		case ')':
		case ',':
		case ';':
		case '@':
		case '[':
		case ']':
		case '~':	goto yy165;
		case '*':	goto yy156;
		case '+':	goto yy152;
		case '-':	goto yy137;
		case '.':	goto yy158;
		case '/':	goto yy157;
		case '0':	goto yy171;
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':	goto yy173;
		case ':':	goto yy141;
		case '<':	goto yy154;
		case '=':	goto yy149;
		case '>':	goto yy155;
		case '?':	goto yy166;
		case 'A':
		case 'a':	goto yy132;
		case 'B':
		case 'b':	goto yy134;
		case 'C':
		case 'c':	goto yy127;
		case 'D':
		case 'd':	goto yy125;
		case 'E':
		case 'e':	goto yy123;
		case 'F':
		case 'f':	goto yy126;
		case 'G':
		case 'g':	goto yy135;
		case 'I':
		case 'i':	goto yy130;
		case 'L':
		case 'l':	goto yy150;
		case 'N':
		case 'n':	goto yy144;
		case 'O':
		case 'o':	goto yy151;
		case 'P':
		case 'p':	goto yy136;
		case 'R':
		case 'r':	goto yy128;
		case 'S':
		case 's':	goto yy133;
		case 'T':
		case 't':	goto yy129;
		case 'U':
		case 'u':	goto yy147;
		case 'V':
		case 'v':	goto yy145;
		case 'W':
		case 'w':	goto yy131;
		case 'X':
		case 'x':	goto yy163;
		case '\\':	goto yy142;
		case '^':	goto yy162;
		case '_':	goto yy148;
		case '`':	goto yy181;
		case '{':	goto yy167;
		case '|':	goto yy161;
		case '}':	goto yy169;
		default:	goto yy174;
		}
yy123:
		YYDEBUG(123, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(-1, yych);
		switch ((yych = *YYCURSOR)) {
		case 'C':
		case 'c':	goto yy812;
		case 'L':
		case 'l':	goto yy813;
		case 'M':
		case 'm':	goto yy814;
		case 'N':
		case 'n':	goto yy815;
		case 'V':
		case 'v':	goto yy816;
		case 'X':
		case 'x':	goto yy817;
		default:	goto yy186;
		}
yy124:
		YYDEBUG(124, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1756 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	return T_STRING;
}
#line 2270 "Zend/zend_language_scanner.c"
yy125:
		YYDEBUG(125, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych <= 'H') {
				if (yych == 'E') goto yy791;
				goto yy186;
			} else {
				if (yych <= 'I') goto yy792;
				if (yych <= 'N') goto yy186;
				goto yy793;
			}
		} else {
			if (yych <= 'h') {
				if (yych == 'e') goto yy791;
				goto yy186;
			} else {
				if (yych <= 'i') goto yy792;
				if (yych == 'o') goto yy793;
				goto yy186;
			}
		}
yy126:
		YYDEBUG(126, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'U') {
			if (yych <= 'L') {
				if (yych == 'I') goto yy767;
				if (yych <= 'K') goto yy186;
				goto yy768;
			} else {
				if (yych == 'O') goto yy769;
				if (yych <= 'T') goto yy186;
				goto yy770;
			}
		} else {
			if (yych <= 'l') {
				if (yych == 'i') goto yy767;
				if (yych <= 'k') goto yy186;
				goto yy768;
			} else {
				if (yych <= 'o') {
					if (yych <= 'n') goto yy186;
					goto yy769;
				} else {
					if (yych == 'u') goto yy770;
					goto yy186;
				}
			}
		}
yy127:
		YYDEBUG(127, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych <= 'K') {
				if (yych == 'A') goto yy739;
				goto yy186;
			} else {
				if (yych <= 'L') goto yy740;
				if (yych <= 'N') goto yy186;
				goto yy741;
			}
		} else {
			if (yych <= 'k') {
				if (yych == 'a') goto yy739;
				goto yy186;
			} else {
				if (yych <= 'l') goto yy740;
				if (yych == 'o') goto yy741;
				goto yy186;
			}
		}
yy128:
		YYDEBUG(128, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy701;
		if (yych == 'e') goto yy701;
		goto yy186;
yy129:
		YYDEBUG(129, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'R') {
			if (yych == 'H') goto yy689;
			if (yych <= 'Q') goto yy186;
			goto yy690;
		} else {
			if (yych <= 'h') {
				if (yych <= 'g') goto yy186;
				goto yy689;
			} else {
				if (yych == 'r') goto yy690;
				goto yy186;
			}
		}
yy130:
		YYDEBUG(130, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'S') {
			if (yych <= 'L') {
				if (yych == 'F') goto yy634;
				goto yy186;
			} else {
				if (yych <= 'M') goto yy636;
				if (yych <= 'N') goto yy637;
				if (yych <= 'R') goto yy186;
				goto yy638;
			}
		} else {
			if (yych <= 'm') {
				if (yych == 'f') goto yy634;
				if (yych <= 'l') goto yy186;
				goto yy636;
			} else {
				if (yych <= 'n') goto yy637;
				if (yych == 's') goto yy638;
				goto yy186;
			}
		}
yy131:
		YYDEBUG(131, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy629;
		if (yych == 'h') goto yy629;
		goto yy186;
yy132:
		YYDEBUG(132, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'S') {
			if (yych <= 'M') {
				if (yych == 'B') goto yy611;
				goto yy186;
			} else {
				if (yych <= 'N') goto yy612;
				if (yych <= 'Q') goto yy186;
				if (yych <= 'R') goto yy613;
				goto yy614;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'b') goto yy611;
				if (yych <= 'm') goto yy186;
				goto yy612;
			} else {
				if (yych <= 'q') goto yy186;
				if (yych <= 'r') goto yy613;
				if (yych <= 's') goto yy614;
				goto yy186;
			}
		}
yy133:
		YYDEBUG(133, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'W') {
			if (yych <= 'S') {
				if (yych == 'C') goto yy585;
				goto yy186;
			} else {
				if (yych <= 'T') goto yy586;
				if (yych <= 'V') goto yy186;
				goto yy587;
			}
		} else {
			if (yych <= 's') {
				if (yych == 'c') goto yy585;
				goto yy186;
			} else {
				if (yych <= 't') goto yy586;
				if (yych == 'w') goto yy587;
				goto yy186;
			}
		}
yy134:
		YYDEBUG(134, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'N') {
			if (yych <= '\'') {
				if (yych == '"') goto yy554;
				if (yych <= '&') goto yy186;
				goto yy555;
			} else {
				if (yych <= '<') {
					if (yych <= ';') goto yy186;
					goto yy553;
				} else {
					if (yych == 'I') goto yy556;
					goto yy186;
				}
			}
		} else {
			if (yych <= 'i') {
				if (yych <= 'Q') {
					if (yych <= 'O') goto yy557;
					goto yy186;
				} else {
					if (yych <= 'R') goto yy558;
					if (yych <= 'h') goto yy186;
					goto yy556;
				}
			} else {
				if (yych <= 'o') {
					if (yych <= 'n') goto yy186;
					goto yy557;
				} else {
					if (yych == 'r') goto yy558;
					goto yy186;
				}
			}
		}
yy135:
		YYDEBUG(135, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'L') goto yy543;
			if (yych <= 'N') goto yy186;
			goto yy544;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy186;
				goto yy543;
			} else {
				if (yych == 'o') goto yy544;
				goto yy186;
			}
		}
yy136:
		YYDEBUG(136, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'U') {
			if (yych == 'R') goto yy519;
			if (yych <= 'T') goto yy186;
			goto yy520;
		} else {
			if (yych <= 'r') {
				if (yych <= 'q') goto yy186;
				goto yy519;
			} else {
				if (yych == 'u') goto yy520;
				goto yy186;
			}
		}
yy137:
		YYDEBUG(137, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '<') {
			if (yych == '-') goto yy515;
		} else {
			if (yych <= '=') goto yy513;
			if (yych <= '>') goto yy517;
		}
yy138:
		YYDEBUG(138, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1349 "Zend/zend_language_scanner.l"
		{
	return yytext[0];
}
#line 2528 "Zend/zend_language_scanner.c"
yy139:
		YYDEBUG(139, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy512;
yy140:
		YYDEBUG(140, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1024 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	HANDLE_NEWLINES(yytext, yyleng);
	return T_WHITESPACE;
}
#line 2545 "Zend/zend_language_scanner.c"
yy141:
		YYDEBUG(141, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == ':') goto yy509;
		goto yy138;
yy142:
		YYDEBUG(142, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(143, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1053 "Zend/zend_language_scanner.l"
		{
	return T_NS_SEPARATOR;
}
#line 2560 "Zend/zend_language_scanner.c"
yy144:
		YYDEBUG(144, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'U') {
			if (yych <= 'D') {
				if (yych == 'A') goto yy485;
				goto yy186;
			} else {
				if (yych <= 'E') goto yy486;
				if (yych <= 'T') goto yy186;
				goto yy487;
			}
		} else {
			if (yych <= 'd') {
				if (yych == 'a') goto yy485;
				goto yy186;
			} else {
				if (yych <= 'e') goto yy486;
				if (yych == 'u') goto yy487;
				goto yy186;
			}
		}
yy145:
		YYDEBUG(145, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy482;
		if (yych == 'a') goto yy482;
		goto yy186;
yy146:
		YYDEBUG(146, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy399;
					if (yych <= 0x1F) goto yy138;
					goto yy399;
				} else {
					if (yych <= '@') goto yy138;
					if (yych == 'C') goto yy138;
					goto yy399;
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy399;
					if (yych <= 'H') goto yy138;
					goto yy399;
				} else {
					if (yych == 'O') goto yy399;
					if (yych <= 'Q') goto yy138;
					goto yy399;
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'b') {
					if (yych == 'U') goto yy399;
					if (yych <= '`') goto yy138;
					goto yy399;
				} else {
					if (yych == 'd') goto yy399;
					if (yych <= 'e') goto yy138;
					goto yy399;
				}
			} else {
				if (yych <= 'o') {
					if (yych == 'i') goto yy399;
					if (yych <= 'n') goto yy138;
					goto yy399;
				} else {
					if (yych <= 's') {
						if (yych <= 'q') goto yy138;
						goto yy399;
					} else {
						if (yych == 'u') goto yy399;
						goto yy138;
					}
				}
			}
		}
yy147:
		YYDEBUG(147, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'S') {
			if (yych == 'N') goto yy390;
			if (yych <= 'R') goto yy186;
			goto yy391;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy186;
				goto yy390;
			} else {
				if (yych == 's') goto yy391;
				goto yy186;
			}
		}
yy148:
		YYDEBUG(148, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '_') goto yy316;
		goto yy186;
yy149:
		YYDEBUG(149, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy138;
		if (yych <= '=') goto yy310;
		if (yych <= '>') goto yy312;
		goto yy138;
yy150:
		YYDEBUG(150, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'I') goto yy297;
			if (yych <= 'N') goto yy186;
			goto yy298;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy186;
				goto yy297;
			} else {
				if (yych == 'o') goto yy298;
				goto yy186;
			}
		}
yy151:
		YYDEBUG(151, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'R') {
			if (yych == 'B') goto yy284;
			if (yych <= 'Q') goto yy186;
			goto yy285;
		} else {
			if (yych <= 'b') {
				if (yych <= 'a') goto yy186;
				goto yy284;
			} else {
				if (yych == 'r') goto yy285;
				goto yy186;
			}
		}
yy152:
		YYDEBUG(152, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '+') goto yy282;
		if (yych == '=') goto yy280;
		goto yy138;
yy153:
		YYDEBUG(153, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy277;
		goto yy138;
yy154:
		YYDEBUG(154, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') {
			if (yych == '/') goto yy249;
			goto yy138;
		} else {
			if (yych <= '<') goto yy247;
			if (yych <= '=') goto yy250;
			if (yych <= '>') goto yy252;
			goto yy138;
		}
yy155:
		YYDEBUG(155, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy138;
		if (yych <= '=') goto yy243;
		if (yych <= '>') goto yy241;
		goto yy138;
yy156:
		YYDEBUG(156, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy239;
		goto yy138;
yy157:
		YYDEBUG(157, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '.') {
			if (yych == '*') goto yy231;
			goto yy138;
		} else {
			if (yych <= '/') goto yy233;
			if (yych == '=') goto yy234;
			goto yy138;
		}
yy158:
		YYDEBUG(158, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '/') goto yy138;
		if (yych <= '9') goto yy227;
		if (yych == '=') goto yy229;
		goto yy138;
yy159:
		YYDEBUG(159, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy138;
		if (yych <= '=') goto yy223;
		if (yych <= '>') goto yy221;
		goto yy138;
yy160:
		YYDEBUG(160, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '&') goto yy217;
		if (yych == '=') goto yy219;
		goto yy138;
yy161:
		YYDEBUG(161, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy215;
		if (yych == '|') goto yy213;
		goto yy138;
yy162:
		YYDEBUG(162, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy211;
		goto yy138;
yy163:
		YYDEBUG(163, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy208;
		if (yych == 'o') goto yy208;
		goto yy186;
yy164:
		YYDEBUG(164, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy138;
			if (yych <= 'Z') goto yy205;
			if (yych <= '^') goto yy138;
			goto yy205;
		} else {
			if (yych <= '`') goto yy138;
			if (yych <= 'z') goto yy205;
			if (yych <= '~') goto yy138;
			goto yy205;
		}
yy165:
		YYDEBUG(165, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy138;
yy166:
		YYDEBUG(166, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy201;
		goto yy138;
yy167:
		YYDEBUG(167, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(168, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1354 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return '{';
}
#line 2819 "Zend/zend_language_scanner.c"
yy169:
		YYDEBUG(169, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(170, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1366 "Zend/zend_language_scanner.l"
		{
	RESET_DOC_COMMENT();
	if (!zend_stack_is_empty(&SCNG(state_stack))) {
		yy_pop_state(TSRMLS_C);
	}
	return '}';
}
#line 2833 "Zend/zend_language_scanner.c"
yy171:
		YYDEBUG(171, *YYCURSOR);
		yyaccept = 2;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') {
				if (yych == '.') goto yy187;
			} else {
				if (yych <= '9') goto yy190;
				if (yych >= 'E') goto yy192;
			}
		} else {
			if (yych <= 'd') {
				if (yych == 'X') goto yy197;
			} else {
				if (yych <= 'e') goto yy192;
				if (yych == 'x') goto yy197;
			}
		}
yy172:
		YYDEBUG(172, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1392 "Zend/zend_language_scanner.l"
		{
	if (yyleng < MAX_LENGTH_OF_LONG - 1) { /* Won't overflow */
		zendlval->value.lval = strtol(yytext, NULL, 0);
	} else {
		errno = 0;
		zendlval->value.lval = strtol(yytext, NULL, 0);
		if (errno == ERANGE) { /* Overflow */
			if (yytext[0] == '0') { /* octal overflow */
				zendlval->value.dval = zend_oct_strtod(yytext, NULL);
			} else {
				zendlval->value.dval = zend_strtod(yytext, NULL);
			}
			zendlval->type = IS_DOUBLE;
			return T_DNUMBER;
		}
	}

	zendlval->type = IS_LONG;
	return T_LNUMBER;
}
#line 2877 "Zend/zend_language_scanner.c"
yy173:
		YYDEBUG(173, *YYCURSOR);
		yyaccept = 2;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '9') {
			if (yych == '.') goto yy187;
			if (yych <= '/') goto yy172;
			goto yy190;
		} else {
			if (yych <= 'E') {
				if (yych <= 'D') goto yy172;
				goto yy192;
			} else {
				if (yych == 'e') goto yy192;
				goto yy172;
			}
		}
yy174:
		YYDEBUG(174, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy186;
yy175:
		YYDEBUG(175, *YYCURSOR);
		++YYCURSOR;
yy176:
		YYDEBUG(176, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1763 "Zend/zend_language_scanner.l"
		{
	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
				if (*YYCURSOR == '\n') {
					YYCURSOR++;
				}
				/* fall through */
			case '\n':
				CG(zend_lineno)++;
				break;
			case '%':
				if (!CG(asp_tags)) {
					continue;
				}
				/* fall through */
			case '?':
				if (*YYCURSOR == '>') {
					YYCURSOR--;
					break;
				}
				/* fall through */
			default:
				continue;
		}

		break;
	}

	yyleng = YYCURSOR - SCNG(yy_text);

	return T_COMMENT;
}
#line 2939 "Zend/zend_language_scanner.c"
yy177:
		YYDEBUG(177, *YYCURSOR);
		++YYCURSOR;
yy178:
		YYDEBUG(178, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1854 "Zend/zend_language_scanner.l"
		{
	register char *s, *t;
	char *end;
	int bprefix = (yytext[0] != '\'') ? 1 : 0;

	while (1) {
		if (YYCURSOR < YYLIMIT) {
			if (*YYCURSOR == '\'') {
				YYCURSOR++;
				yyleng = YYCURSOR - SCNG(yy_text);

				break;
			} else if (*YYCURSOR++ == '\\' && YYCURSOR < YYLIMIT) {
				YYCURSOR++;
			}
		} else {
			yyleng = YYLIMIT - SCNG(yy_text);

			/* Unclosed single quotes; treat similar to double quotes, but without a separate token
			 * for ' (unrecognized by parser), instead of old flex fallback to "Unexpected character..."
			 * rule, which continued in ST_IN_SCRIPTING state after the quote */
			return T_ENCAPSED_AND_WHITESPACE;
		}
	}

	zendlval->value.str.val = estrndup(yytext+bprefix+1, yyleng-bprefix-2);
	zendlval->value.str.len = yyleng-bprefix-2;
	zendlval->type = IS_STRING;

	/* convert escape sequences */
	s = t = zendlval->value.str.val;
	end = s+zendlval->value.str.len;
	while (s<end) {
		if (*s=='\\') {
			s++;

			switch(*s) {
				case '\\':
				case '\'':
					*t++ = *s;
					zendlval->value.str.len--;
					break;
				default:
					*t++ = '\\';
					*t++ = *s;
					break;
			}
		} else {
			*t++ = *s;
		}

		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;

#ifdef ZEND_MULTIBYTE
	if (SCNG(output_filter)) {
		size_t sz = 0;
		s = zendlval->value.str.val;
		SCNG(output_filter)((unsigned char **)&(zendlval->value.str.val), &sz, (unsigned char *)s, (size_t)zendlval->value.str.len TSRMLS_CC);
		zendlval->value.str.len = sz;
		efree(s);
	}
#endif /* ZEND_MULTIBYTE */
	return T_CONSTANT_ENCAPSED_STRING;
}
#line 3016 "Zend/zend_language_scanner.c"
yy179:
		YYDEBUG(179, *YYCURSOR);
		++YYCURSOR;
yy180:
		YYDEBUG(180, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1925 "Zend/zend_language_scanner.l"
		{
	int bprefix = (yytext[0] != '"') ? 1 : 0;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '"':
				yyleng = YYCURSOR - SCNG(yy_text);
				zend_scan_escape_string(zendlval, yytext+bprefix+1, yyleng-bprefix-2, '"' TSRMLS_CC);
				return T_CONSTANT_ENCAPSED_STRING;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				/* fall through */
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

	/* Remember how much was scanned to save rescanning */
	SET_DOUBLE_QUOTES_SCANNED_LENGTH(YYCURSOR - SCNG(yy_text) - yyleng);

	YYCURSOR = SCNG(yy_text) + yyleng;

	BEGIN(ST_DOUBLE_QUOTES);
	return '"';
}
#line 3064 "Zend/zend_language_scanner.c"
yy181:
		YYDEBUG(181, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(182, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2016 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_BACKQUOTE);
	return '`';
}
#line 3075 "Zend/zend_language_scanner.c"
yy183:
		YYDEBUG(183, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(184, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2274 "Zend/zend_language_scanner.l"
		{
	if (YYCURSOR > YYLIMIT) {
		return 0;
	}

	zend_error(E_COMPILE_WARNING,"Unexpected character in input:  '%c' (ASCII=%d) state=%d", yytext[0], yytext[0], YYSTATE);
	goto restart;
}
#line 3090 "Zend/zend_language_scanner.c"
yy185:
		YYDEBUG(185, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy186:
		YYDEBUG(186, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy185;
		}
		goto yy124;
yy187:
		YYDEBUG(187, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(188, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy187;
		}
		if (yych == 'E') goto yy192;
		if (yych == 'e') goto yy192;
yy189:
		YYDEBUG(189, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1453 "Zend/zend_language_scanner.l"
		{
	zendlval->value.dval = zend_strtod(yytext, NULL);
	zendlval->type = IS_DOUBLE;
	return T_DNUMBER;
}
#line 3123 "Zend/zend_language_scanner.c"
yy190:
		YYDEBUG(190, *YYCURSOR);
		yyaccept = 2;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(191, *YYCURSOR);
		if (yych <= '9') {
			if (yych == '.') goto yy187;
			if (yych <= '/') goto yy172;
			goto yy190;
		} else {
			if (yych <= 'E') {
				if (yych <= 'D') goto yy172;
			} else {
				if (yych != 'e') goto yy172;
			}
		}
yy192:
		YYDEBUG(192, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= ',') {
			if (yych == '+') goto yy194;
		} else {
			if (yych <= '-') goto yy194;
			if (yych <= '/') goto yy193;
			if (yych <= '9') goto yy195;
		}
yy193:
		YYDEBUG(193, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 2) {
			if (yyaccept <= 1) {
				if (yyaccept <= 0) {
					goto yy124;
				} else {
					goto yy138;
				}
			} else {
				goto yy172;
			}
		} else {
			if (yyaccept <= 4) {
				if (yyaccept <= 3) {
					goto yy189;
				} else {
					goto yy232;
				}
			} else {
				goto yy248;
			}
		}
yy194:
		YYDEBUG(194, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '/') goto yy193;
		if (yych >= ':') goto yy193;
yy195:
		YYDEBUG(195, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(196, *YYCURSOR);
		if (yych <= '/') goto yy189;
		if (yych <= '9') goto yy195;
		goto yy189;
yy197:
		YYDEBUG(197, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy198;
		}
		goto yy193;
yy198:
		YYDEBUG(198, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(199, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy198;
		}
		YYDEBUG(200, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1413 "Zend/zend_language_scanner.l"
		{
	char *hex = yytext + 2; /* Skip "0x" */
	int len = yyleng - 2;

	/* Skip any leading 0s */
	while (*hex == '0') {
		hex++;
		len--;
	}

	if (len < SIZEOF_LONG * 2 || (len == SIZEOF_LONG * 2 && *hex <= '7')) {
		zendlval->value.lval = strtol(hex, NULL, 16);
		zendlval->type = IS_LONG;
		return T_LNUMBER;
	} else {
		zendlval->value.dval = zend_hex_strtod(hex, NULL);
		zendlval->type = IS_DOUBLE;
		return T_DNUMBER;
	}
}
#line 3229 "Zend/zend_language_scanner.c"
yy201:
		YYDEBUG(201, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy203;
		if (yych == '\r') goto yy204;
yy202:
		YYDEBUG(202, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1831 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	BEGIN(INITIAL);
	return T_CLOSE_TAG;  /* implicit ';' at php-end tag */
}
#line 3246 "Zend/zend_language_scanner.c"
yy203:
		YYDEBUG(203, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy202;
yy204:
		YYDEBUG(204, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy203;
		goto yy202;
yy205:
		YYDEBUG(205, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(206, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy205;
			} else {
				if (yych <= '@') goto yy207;
				if (yych <= 'Z') goto yy205;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy205;
			} else {
				if (yych <= 'z') goto yy205;
				if (yych >= 0x7F) goto yy205;
			}
		}
yy207:
		YYDEBUG(207, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1733 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 3286 "Zend/zend_language_scanner.c"
yy208:
		YYDEBUG(208, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy209;
		if (yych != 'r') goto yy186;
yy209:
		YYDEBUG(209, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(210, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1337 "Zend/zend_language_scanner.l"
		{
	return T_LOGICAL_XOR;
}
#line 3304 "Zend/zend_language_scanner.c"
yy211:
		YYDEBUG(211, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(212, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1317 "Zend/zend_language_scanner.l"
		{
	return T_XOR_EQUAL;
}
#line 3314 "Zend/zend_language_scanner.c"
yy213:
		YYDEBUG(213, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(214, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1321 "Zend/zend_language_scanner.l"
		{
	return T_BOOLEAN_OR;
}
#line 3324 "Zend/zend_language_scanner.c"
yy215:
		YYDEBUG(215, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(216, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1313 "Zend/zend_language_scanner.l"
		{
	return T_OR_EQUAL;
}
#line 3334 "Zend/zend_language_scanner.c"
yy217:
		YYDEBUG(217, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(218, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1325 "Zend/zend_language_scanner.l"
		{
	return T_BOOLEAN_AND;
}
#line 3344 "Zend/zend_language_scanner.c"
yy219:
		YYDEBUG(219, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(220, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1309 "Zend/zend_language_scanner.l"
		{
	return T_AND_EQUAL;
}
#line 3354 "Zend/zend_language_scanner.c"
yy221:
		YYDEBUG(221, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy225;
		if (yych == '\r') goto yy226;
yy222:
		YYDEBUG(222, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1840 "Zend/zend_language_scanner.l"
		{
	if (CG(asp_tags)) {
		BEGIN(INITIAL);
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
		zendlval->value.str.val = yytext; /* no copying - intentional */
		return T_CLOSE_TAG;  /* implicit ';' at php-end tag */
	} else {
		yyless(1);
		return yytext[0];
	}
}
#line 3376 "Zend/zend_language_scanner.c"
yy223:
		YYDEBUG(223, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(224, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1297 "Zend/zend_language_scanner.l"
		{
	return T_MOD_EQUAL;
}
#line 3386 "Zend/zend_language_scanner.c"
yy225:
		YYDEBUG(225, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy222;
yy226:
		YYDEBUG(226, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy225;
		goto yy222;
yy227:
		YYDEBUG(227, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(228, *YYCURSOR);
		if (yych <= 'D') {
			if (yych <= '/') goto yy189;
			if (yych <= '9') goto yy227;
			goto yy189;
		} else {
			if (yych <= 'E') goto yy192;
			if (yych == 'e') goto yy192;
			goto yy189;
		}
yy229:
		YYDEBUG(229, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(230, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1293 "Zend/zend_language_scanner.l"
		{
	return T_CONCAT_EQUAL;
}
#line 3421 "Zend/zend_language_scanner.c"
yy231:
		YYDEBUG(231, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '*') goto yy236;
yy232:
		YYDEBUG(232, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1797 "Zend/zend_language_scanner.l"
		{
	int doc_com;

	if (yyleng > 2) {
		doc_com = 1;
		RESET_DOC_COMMENT();
	} else {
		doc_com = 0;
	}

	while (YYCURSOR < YYLIMIT) {
		if (*YYCURSOR++ == '*' && *YYCURSOR == '/') {
			break;
		}
	}

	if (YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	} else {
		zend_error(E_COMPILE_WARNING, "Unterminated comment starting line %d", CG(zend_lineno));
	}

	yyleng = YYCURSOR - SCNG(yy_text);
	HANDLE_NEWLINES(yytext, yyleng);

	if (doc_com) {
		CG(doc_comment) = estrndup(yytext, yyleng);
		CG(doc_comment_len) = yyleng;
		return T_DOC_COMMENT;
	}

	return T_COMMENT;
}
#line 3464 "Zend/zend_language_scanner.c"
yy233:
		YYDEBUG(233, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy176;
yy234:
		YYDEBUG(234, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(235, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1289 "Zend/zend_language_scanner.l"
		{
	return T_DIV_EQUAL;
}
#line 3478 "Zend/zend_language_scanner.c"
yy236:
		YYDEBUG(236, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy237;
		}
		goto yy193;
yy237:
		YYDEBUG(237, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(238, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy237;
		}
		goto yy232;
yy239:
		YYDEBUG(239, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(240, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1285 "Zend/zend_language_scanner.l"
		{
	return T_MUL_EQUAL;
}
#line 3505 "Zend/zend_language_scanner.c"
yy241:
		YYDEBUG(241, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy245;
		YYDEBUG(242, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1345 "Zend/zend_language_scanner.l"
		{
	return T_SR;
}
#line 3516 "Zend/zend_language_scanner.c"
yy243:
		YYDEBUG(243, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(244, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1273 "Zend/zend_language_scanner.l"
		{
	return T_IS_GREATER_OR_EQUAL;
}
#line 3526 "Zend/zend_language_scanner.c"
yy245:
		YYDEBUG(245, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(246, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1305 "Zend/zend_language_scanner.l"
		{
	return T_SR_EQUAL;
}
#line 3536 "Zend/zend_language_scanner.c"
yy247:
		YYDEBUG(247, *YYCURSOR);
		yyaccept = 5;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') goto yy248;
		if (yych <= '<') goto yy263;
		if (yych <= '=') goto yy261;
yy248:
		YYDEBUG(248, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1341 "Zend/zend_language_scanner.l"
		{
	return T_SL;
}
#line 3551 "Zend/zend_language_scanner.c"
yy249:
		YYDEBUG(249, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy254;
		if (yych == 's') goto yy254;
		goto yy193;
yy250:
		YYDEBUG(250, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(251, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1269 "Zend/zend_language_scanner.l"
		{
	return T_IS_SMALLER_OR_EQUAL;
}
#line 3567 "Zend/zend_language_scanner.c"
yy252:
		YYDEBUG(252, *YYCURSOR);
		++YYCURSOR;
yy253:
		YYDEBUG(253, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1265 "Zend/zend_language_scanner.l"
		{
	return T_IS_NOT_EQUAL;
}
#line 3578 "Zend/zend_language_scanner.c"
yy254:
		YYDEBUG(254, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy255;
		if (yych != 'c') goto yy193;
yy255:
		YYDEBUG(255, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy256;
		if (yych != 'r') goto yy193;
yy256:
		YYDEBUG(256, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy257;
		if (yych != 'i') goto yy193;
yy257:
		YYDEBUG(257, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy258;
		if (yych != 'p') goto yy193;
yy258:
		YYDEBUG(258, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy259;
		if (yych != 't') goto yy193;
yy259:
		YYDEBUG(259, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(260, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy193;
			if (yych <= '\n') goto yy259;
			if (yych <= '\f') goto yy193;
			goto yy259;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy193;
				goto yy259;
			} else {
				if (yych == '>') goto yy201;
				goto yy193;
			}
		}
yy261:
		YYDEBUG(261, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(262, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1301 "Zend/zend_language_scanner.l"
		{
	return T_SL_EQUAL;
}
#line 3633 "Zend/zend_language_scanner.c"
yy263:
		YYDEBUG(263, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(264, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy263;
		}
		if (yych <= 'Z') {
			if (yych <= '&') {
				if (yych == '"') goto yy268;
				goto yy193;
			} else {
				if (yych <= '\'') goto yy267;
				if (yych <= '@') goto yy193;
			}
		} else {
			if (yych <= '`') {
				if (yych != '_') goto yy193;
			} else {
				if (yych <= 'z') goto yy265;
				if (yych <= '~') goto yy193;
			}
		}
yy265:
		YYDEBUG(265, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(266, *YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\f') {
				if (yych == '\n') goto yy272;
				goto yy193;
			} else {
				if (yych <= '\r') goto yy274;
				if (yych <= '/') goto yy193;
				if (yych <= '9') goto yy265;
				goto yy193;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy265;
				if (yych <= '^') goto yy193;
				goto yy265;
			} else {
				if (yych <= '`') goto yy193;
				if (yych <= 'z') goto yy265;
				if (yych <= '~') goto yy193;
				goto yy265;
			}
		}
yy267:
		YYDEBUG(267, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\'') goto yy193;
		if (yych <= '/') goto yy276;
		if (yych <= '9') goto yy193;
		goto yy276;
yy268:
		YYDEBUG(268, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '"') goto yy193;
		if (yych <= '/') goto yy270;
		if (yych <= '9') goto yy193;
		goto yy270;
yy269:
		YYDEBUG(269, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy270:
		YYDEBUG(270, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych != '"') goto yy193;
			} else {
				if (yych <= '9') goto yy269;
				if (yych <= '@') goto yy193;
				goto yy269;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy269;
				goto yy193;
			} else {
				if (yych <= 'z') goto yy269;
				if (yych <= '~') goto yy193;
				goto yy269;
			}
		}
yy271:
		YYDEBUG(271, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy272;
		if (yych == '\r') goto yy274;
		goto yy193;
yy272:
		YYDEBUG(272, *YYCURSOR);
		++YYCURSOR;
yy273:
		YYDEBUG(273, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1967 "Zend/zend_language_scanner.l"
		{
	char *s;
	int bprefix = (yytext[0] != '<') ? 1 : 0;

	/* save old heredoc label */
	Z_STRVAL_P(zendlval) = CG(heredoc);
	Z_STRLEN_P(zendlval) = CG(heredoc_len);

	CG(zend_lineno)++;
	CG(heredoc_len) = yyleng-bprefix-3-1-(yytext[yyleng-2]=='\r'?1:0);
	s = yytext+bprefix+3;
	while ((*s == ' ') || (*s == '\t')) {
		s++;
		CG(heredoc_len)--;
	}

	if (*s == '\'') {
		s++;
		CG(heredoc_len) -= 2;

		BEGIN(ST_NOWDOC);
	} else {
		if (*s == '"') {
			s++;
			CG(heredoc_len) -= 2;
		}

		BEGIN(ST_HEREDOC);
	}

	CG(heredoc) = estrndup(s, CG(heredoc_len));

	/* Check for ending label on the next line */
	if (CG(heredoc_len) < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, s, CG(heredoc_len))) {
		YYCTYPE *end = YYCURSOR + CG(heredoc_len);

		if (*end == ';') {
			end++;
		}

		if (*end == '\n' || *end == '\r') {
			BEGIN(ST_END_HEREDOC);
		}
	}

	return T_START_HEREDOC;
}
#line 3786 "Zend/zend_language_scanner.c"
yy274:
		YYDEBUG(274, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy272;
		goto yy273;
yy275:
		YYDEBUG(275, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy276:
		YYDEBUG(276, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych == '\'') goto yy271;
				goto yy193;
			} else {
				if (yych <= '9') goto yy275;
				if (yych <= '@') goto yy193;
				goto yy275;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy275;
				goto yy193;
			} else {
				if (yych <= 'z') goto yy275;
				if (yych <= '~') goto yy193;
				goto yy275;
			}
		}
yy277:
		YYDEBUG(277, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '=') goto yy253;
		YYDEBUG(278, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(279, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1257 "Zend/zend_language_scanner.l"
		{
	return T_IS_NOT_IDENTICAL;
}
#line 3830 "Zend/zend_language_scanner.c"
yy280:
		YYDEBUG(280, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(281, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1277 "Zend/zend_language_scanner.l"
		{
	return T_PLUS_EQUAL;
}
#line 3840 "Zend/zend_language_scanner.c"
yy282:
		YYDEBUG(282, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(283, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1245 "Zend/zend_language_scanner.l"
		{
	return T_INC;
}
#line 3850 "Zend/zend_language_scanner.c"
yy284:
		YYDEBUG(284, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'J') goto yy287;
		if (yych == 'j') goto yy287;
		goto yy186;
yy285:
		YYDEBUG(285, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(286, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1329 "Zend/zend_language_scanner.l"
		{
	return T_LOGICAL_OR;
}
#line 3869 "Zend/zend_language_scanner.c"
yy287:
		YYDEBUG(287, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy288;
		if (yych != 'e') goto yy186;
yy288:
		YYDEBUG(288, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy289;
		if (yych != 'c') goto yy186;
yy289:
		YYDEBUG(289, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy290;
		if (yych != 't') goto yy186;
yy290:
		YYDEBUG(290, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy185;
		}
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy124;
				goto yy292;
			} else {
				if (yych == '\r') goto yy292;
				goto yy124;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy292;
				if (yych <= '#') goto yy124;
				goto yy292;
			} else {
				if (yych == '&') goto yy292;
				goto yy124;
			}
		}
yy291:
		YYDEBUG(291, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy292:
		YYDEBUG(292, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				if (yych <= '\t') goto yy291;
			} else {
				if (yych != '\r') goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy291;
				if (yych <= '#') goto yy193;
				goto yy295;
			} else {
				if (yych != '&') goto yy193;
			}
		}
yy293:
		YYDEBUG(293, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(294, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy293;
		}
		if (yych != '$') goto yy193;
yy295:
		YYDEBUG(295, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(296, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1240 "Zend/zend_language_scanner.l"
		{
	yyless((sizeof("object") - 1));
	return T_OBJECT_HINT;
}
#line 3953 "Zend/zend_language_scanner.c"
yy297:
		YYDEBUG(297, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy307;
		if (yych == 's') goto yy307;
		goto yy186;
yy298:
		YYDEBUG(298, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy299;
		if (yych != 'n') goto yy186;
yy299:
		YYDEBUG(299, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy300;
		if (yych != 'g') goto yy186;
yy300:
		YYDEBUG(300, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy185;
		}
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy124;
				goto yy302;
			} else {
				if (yych == '\r') goto yy302;
				goto yy124;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy302;
				if (yych <= '#') goto yy124;
				goto yy302;
			} else {
				if (yych == '&') goto yy302;
				goto yy124;
			}
		}
yy301:
		YYDEBUG(301, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy302:
		YYDEBUG(302, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				if (yych <= '\t') goto yy301;
			} else {
				if (yych != '\r') goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy301;
				if (yych <= '#') goto yy193;
				goto yy305;
			} else {
				if (yych != '&') goto yy193;
			}
		}
yy303:
		YYDEBUG(303, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(304, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				goto yy303;
			} else {
				if (yych == '\r') goto yy303;
				goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy303;
				if (yych <= '#') goto yy193;
			} else {
				if (yych == '&') goto yy303;
				goto yy193;
			}
		}
yy305:
		YYDEBUG(305, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(306, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1213 "Zend/zend_language_scanner.l"
		{
	if (yytext[3] == 'e') {
		yyless((sizeof("integer") - 1));
	} else 	if (yytext[3] == 'g') {
		yyless((sizeof("long") - 1));
	} else {
		yyless(3);
	}
	return T_INT_HINT;
}
#line 4057 "Zend/zend_language_scanner.c"
yy307:
		YYDEBUG(307, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy308;
		if (yych != 't') goto yy186;
yy308:
		YYDEBUG(308, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(309, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1181 "Zend/zend_language_scanner.l"
		{
	return T_LIST;
}
#line 4075 "Zend/zend_language_scanner.c"
yy310:
		YYDEBUG(310, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy314;
		YYDEBUG(311, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1261 "Zend/zend_language_scanner.l"
		{
	return T_IS_EQUAL;
}
#line 4086 "Zend/zend_language_scanner.c"
yy312:
		YYDEBUG(312, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(313, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1177 "Zend/zend_language_scanner.l"
		{
	return T_DOUBLE_ARROW;
}
#line 4096 "Zend/zend_language_scanner.c"
yy314:
		YYDEBUG(314, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(315, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1253 "Zend/zend_language_scanner.l"
		{
	return T_IS_IDENTICAL;
}
#line 4106 "Zend/zend_language_scanner.c"
yy316:
		YYDEBUG(316, *YYCURSOR);
		yych = *++YYCURSOR;
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'C':
		case 'c':	goto yy318;
		case 'D':
		case 'd':	goto yy322;
		case 'F':
		case 'f':	goto yy319;
		case 'H':
		case 'h':	goto yy317;
		case 'L':
		case 'l':	goto yy321;
		case 'M':
		case 'm':	goto yy320;
		case 'N':
		case 'n':	goto yy323;
		default:	goto yy186;
		}
yy317:
		YYDEBUG(317, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy377;
		if (yych == 'a') goto yy377;
		goto yy186;
yy318:
		YYDEBUG(318, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy370;
		if (yych == 'l') goto yy370;
		goto yy186;
yy319:
		YYDEBUG(319, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'U') {
			if (yych == 'I') goto yy354;
			if (yych <= 'T') goto yy186;
			goto yy355;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy186;
				goto yy354;
			} else {
				if (yych == 'u') goto yy355;
				goto yy186;
			}
		}
yy320:
		YYDEBUG(320, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy346;
		if (yych == 'e') goto yy346;
		goto yy186;
yy321:
		YYDEBUG(321, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy340;
		if (yych == 'i') goto yy340;
		goto yy186;
yy322:
		YYDEBUG(322, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy335;
		if (yych == 'i') goto yy335;
		goto yy186;
yy323:
		YYDEBUG(323, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy324;
		if (yych != 'a') goto yy186;
yy324:
		YYDEBUG(324, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy325;
		if (yych != 'm') goto yy186;
yy325:
		YYDEBUG(325, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy326;
		if (yych != 'e') goto yy186;
yy326:
		YYDEBUG(326, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy327;
		if (yych != 's') goto yy186;
yy327:
		YYDEBUG(327, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy328;
		if (yych != 'p') goto yy186;
yy328:
		YYDEBUG(328, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy329;
		if (yych != 'a') goto yy186;
yy329:
		YYDEBUG(329, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy330;
		if (yych != 'c') goto yy186;
yy330:
		YYDEBUG(330, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy331;
		if (yych != 'e') goto yy186;
yy331:
		YYDEBUG(331, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(332, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(333, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(334, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1557 "Zend/zend_language_scanner.l"
		{
	if (CG(current_namespace)) {
		*zendlval = *CG(current_namespace);
		zval_copy_ctor(zendlval);
	} else {
		ZVAL_EMPTY_STRING(zendlval);
	}
	return T_NS_C;
}
#line 4238 "Zend/zend_language_scanner.c"
yy335:
		YYDEBUG(335, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy336;
		if (yych != 'r') goto yy186;
yy336:
		YYDEBUG(336, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(337, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(338, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(339, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1530 "Zend/zend_language_scanner.l"
		{
	char *filename = zend_get_compiled_filename(TSRMLS_C);
	const size_t filename_len = strlen(filename);
	char *dirname;

	if (!filename) {
		filename = "";
	}

	dirname = estrndup(filename, filename_len);
	zend_dirname(dirname, filename_len);

	if (strcmp(dirname, ".") == 0) {
		dirname = erealloc(dirname, MAXPATHLEN);
#if HAVE_GETCWD
		VCWD_GETCWD(dirname, MAXPATHLEN);
#elif HAVE_GETWD
		VCWD_GETWD(dirname);
#endif
	}

	zendlval->value.str.len = strlen(dirname);
	zendlval->value.str.val = dirname;
	zendlval->type = IS_STRING;
	return T_DIR;
}
#line 4285 "Zend/zend_language_scanner.c"
yy340:
		YYDEBUG(340, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy341;
		if (yych != 'n') goto yy186;
yy341:
		YYDEBUG(341, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy342;
		if (yych != 'e') goto yy186;
yy342:
		YYDEBUG(342, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(343, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(344, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(345, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1512 "Zend/zend_language_scanner.l"
		{
	zendlval->value.lval = CG(zend_lineno);
	zendlval->type = IS_LONG;
	return T_LINE;
}
#line 4316 "Zend/zend_language_scanner.c"
yy346:
		YYDEBUG(346, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy347;
		if (yych != 't') goto yy186;
yy347:
		YYDEBUG(347, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy348;
		if (yych != 'h') goto yy186;
yy348:
		YYDEBUG(348, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy349;
		if (yych != 'o') goto yy186;
yy349:
		YYDEBUG(349, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy350;
		if (yych != 'd') goto yy186;
yy350:
		YYDEBUG(350, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(351, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(352, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(353, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1491 "Zend/zend_language_scanner.l"
		{
	char *class_name = CG(active_class_entry) ? CG(active_class_entry)->name : NULL;
	char *func_name = CG(active_op_array)? CG(active_op_array)->function_name : NULL;
	size_t len = 0;

	if (class_name) {
		len += strlen(class_name) + 2;
	}
	if (func_name) {
		len += strlen(func_name);
	}

	zendlval->value.str.len = zend_spprintf(&zendlval->value.str.val, 0, "%s%s%s", 
		class_name ? class_name : "",
		class_name && func_name ? "::" : "",
		func_name ? func_name : ""
		);
	zendlval->type = IS_STRING;
	return T_METHOD_C;
}
#line 4372 "Zend/zend_language_scanner.c"
yy354:
		YYDEBUG(354, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy365;
		if (yych == 'l') goto yy365;
		goto yy186;
yy355:
		YYDEBUG(355, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy356;
		if (yych != 'n') goto yy186;
yy356:
		YYDEBUG(356, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy357;
		if (yych != 'c') goto yy186;
yy357:
		YYDEBUG(357, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy358;
		if (yych != 't') goto yy186;
yy358:
		YYDEBUG(358, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy359;
		if (yych != 'i') goto yy186;
yy359:
		YYDEBUG(359, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy360;
		if (yych != 'o') goto yy186;
yy360:
		YYDEBUG(360, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy361;
		if (yych != 'n') goto yy186;
yy361:
		YYDEBUG(361, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(362, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(363, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(364, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1475 "Zend/zend_language_scanner.l"
		{
	char *func_name = NULL;

	if (CG(active_op_array)) {
		func_name = CG(active_op_array)->function_name;
	}

	if (!func_name) {
		func_name = "";
	}
	zendlval->value.str.len = strlen(func_name);
	zendlval->value.str.val = estrndup(func_name, zendlval->value.str.len);
	zendlval->type = IS_STRING;
	return T_FUNC_C;
}
#line 4439 "Zend/zend_language_scanner.c"
yy365:
		YYDEBUG(365, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy366;
		if (yych != 'e') goto yy186;
yy366:
		YYDEBUG(366, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(367, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(368, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(369, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1518 "Zend/zend_language_scanner.l"
		{
	char *filename = zend_get_compiled_filename(TSRMLS_C);

	if (!filename) {
		filename = "";
	}
	zendlval->value.str.len = strlen(filename);
	zendlval->value.str.val = estrndup(filename, zendlval->value.str.len);
	zendlval->type = IS_STRING;
	return T_FILE;
}
#line 4471 "Zend/zend_language_scanner.c"
yy370:
		YYDEBUG(370, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy371;
		if (yych != 'a') goto yy186;
yy371:
		YYDEBUG(371, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy372;
		if (yych != 's') goto yy186;
yy372:
		YYDEBUG(372, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy373;
		if (yych != 's') goto yy186;
yy373:
		YYDEBUG(373, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(374, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(375, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(376, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1459 "Zend/zend_language_scanner.l"
		{
	char *class_name = NULL;

	if (CG(active_class_entry)) {
		class_name = CG(active_class_entry)->name;
	}

	if (!class_name) {
		class_name = "";
	}
	zendlval->value.str.len = strlen(class_name);
	zendlval->value.str.val = estrndup(class_name, zendlval->value.str.len);
	zendlval->type = IS_STRING;
	return T_CLASS_C;
}
#line 4517 "Zend/zend_language_scanner.c"
yy377:
		YYDEBUG(377, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy378;
		if (yych != 'l') goto yy186;
yy378:
		YYDEBUG(378, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy379;
		if (yych != 't') goto yy186;
yy379:
		YYDEBUG(379, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '_') goto yy186;
		YYDEBUG(380, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy381;
		if (yych != 'c') goto yy186;
yy381:
		YYDEBUG(381, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy382;
		if (yych != 'o') goto yy186;
yy382:
		YYDEBUG(382, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy383;
		if (yych != 'm') goto yy186;
yy383:
		YYDEBUG(383, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy384;
		if (yych != 'p') goto yy186;
yy384:
		YYDEBUG(384, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy385;
		if (yych != 'i') goto yy186;
yy385:
		YYDEBUG(385, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy386;
		if (yych != 'l') goto yy186;
yy386:
		YYDEBUG(386, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy387;
		if (yych != 'e') goto yy186;
yy387:
		YYDEBUG(387, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy388;
		if (yych != 'r') goto yy186;
yy388:
		YYDEBUG(388, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(389, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1145 "Zend/zend_language_scanner.l"
		{
	return T_HALT_COMPILER;
}
#line 4583 "Zend/zend_language_scanner.c"
yy390:
		YYDEBUG(390, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy394;
		if (yych == 's') goto yy394;
		goto yy186;
yy391:
		YYDEBUG(391, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy392;
		if (yych != 'e') goto yy186;
yy392:
		YYDEBUG(392, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(393, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1125 "Zend/zend_language_scanner.l"
		{
	return T_USE;
}
#line 4607 "Zend/zend_language_scanner.c"
yy394:
		YYDEBUG(394, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy395;
		if (yych != 'e') goto yy186;
yy395:
		YYDEBUG(395, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy396;
		if (yych != 't') goto yy186;
yy396:
		YYDEBUG(396, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(397, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1173 "Zend/zend_language_scanner.l"
		{
	return T_UNSET;
}
#line 4630 "Zend/zend_language_scanner.c"
yy398:
		YYDEBUG(398, *YYCURSOR);
		++YYCURSOR;
		YYFILL(7);
		yych = *YYCURSOR;
yy399:
		YYDEBUG(399, *YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy398;
					if (yych <= 0x1F) goto yy193;
					goto yy398;
				} else {
					if (yych <= 'A') {
						if (yych <= '@') goto yy193;
						goto yy403;
					} else {
						if (yych <= 'B') goto yy401;
						if (yych <= 'C') goto yy193;
						goto yy406;
					}
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy407;
					if (yych <= 'H') goto yy193;
					goto yy408;
				} else {
					if (yych <= 'O') {
						if (yych <= 'N') goto yy193;
						goto yy402;
					} else {
						if (yych <= 'Q') goto yy193;
						if (yych <= 'R') goto yy405;
						goto yy404;
					}
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'a') {
					if (yych == 'U') goto yy400;
					if (yych <= '`') goto yy193;
					goto yy403;
				} else {
					if (yych <= 'c') {
						if (yych <= 'b') goto yy401;
						goto yy193;
					} else {
						if (yych <= 'd') goto yy406;
						if (yych <= 'e') goto yy193;
						goto yy407;
					}
				}
			} else {
				if (yych <= 'q') {
					if (yych <= 'i') {
						if (yych <= 'h') goto yy193;
						goto yy408;
					} else {
						if (yych == 'o') goto yy402;
						goto yy193;
					}
				} else {
					if (yych <= 's') {
						if (yych <= 'r') goto yy405;
						goto yy404;
					} else {
						if (yych != 'u') goto yy193;
					}
				}
			}
		}
yy400:
		YYDEBUG(400, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy475;
		if (yych == 'n') goto yy475;
		goto yy193;
yy401:
		YYDEBUG(401, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'I') goto yy462;
			if (yych <= 'N') goto yy193;
			goto yy463;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy193;
				goto yy462;
			} else {
				if (yych == 'o') goto yy463;
				goto yy193;
			}
		}
yy402:
		YYDEBUG(402, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy454;
		if (yych == 'b') goto yy454;
		goto yy193;
yy403:
		YYDEBUG(403, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy447;
		if (yych == 'r') goto yy447;
		goto yy193;
yy404:
		YYDEBUG(404, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych == 'C') goto yy432;
			if (yych <= 'S') goto yy193;
			goto yy431;
		} else {
			if (yych <= 'c') {
				if (yych <= 'b') goto yy193;
				goto yy432;
			} else {
				if (yych == 't') goto yy431;
				goto yy193;
			}
		}
yy405:
		YYDEBUG(405, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy429;
		if (yych == 'e') goto yy429;
		goto yy193;
yy406:
		YYDEBUG(406, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy425;
		if (yych == 'o') goto yy425;
		goto yy193;
yy407:
		YYDEBUG(407, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy418;
		if (yych == 'l') goto yy418;
		goto yy193;
yy408:
		YYDEBUG(408, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy409;
		if (yych != 'n') goto yy193;
yy409:
		YYDEBUG(409, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy410;
		if (yych != 't') goto yy193;
yy410:
		YYDEBUG(410, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy411;
		if (yych != 'e') goto yy413;
yy411:
		YYDEBUG(411, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy416;
		if (yych == 'g') goto yy416;
		goto yy193;
yy412:
		YYDEBUG(412, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy413:
		YYDEBUG(413, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy412;
			goto yy193;
		} else {
			if (yych <= ' ') goto yy412;
			if (yych != ')') goto yy193;
		}
		YYDEBUG(414, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(415, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1069 "Zend/zend_language_scanner.l"
		{
	return T_INT_CAST;
}
#line 4816 "Zend/zend_language_scanner.c"
yy416:
		YYDEBUG(416, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy417;
		if (yych != 'e') goto yy193;
yy417:
		YYDEBUG(417, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy412;
		if (yych == 'r') goto yy412;
		goto yy193;
yy418:
		YYDEBUG(418, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy419;
		if (yych != 'o') goto yy193;
yy419:
		YYDEBUG(419, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy420;
		if (yych != 'a') goto yy193;
yy420:
		YYDEBUG(420, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy421;
		if (yych != 't') goto yy193;
yy421:
		YYDEBUG(421, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(422, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy421;
			goto yy193;
		} else {
			if (yych <= ' ') goto yy421;
			if (yych != ')') goto yy193;
		}
		YYDEBUG(423, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(424, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1073 "Zend/zend_language_scanner.l"
		{
	return T_DOUBLE_CAST;
}
#line 4864 "Zend/zend_language_scanner.c"
yy425:
		YYDEBUG(425, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy426;
		if (yych != 'u') goto yy193;
yy426:
		YYDEBUG(426, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy427;
		if (yych != 'b') goto yy193;
yy427:
		YYDEBUG(427, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy428;
		if (yych != 'l') goto yy193;
yy428:
		YYDEBUG(428, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy421;
		if (yych == 'e') goto yy421;
		goto yy193;
yy429:
		YYDEBUG(429, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy430;
		if (yych != 'a') goto yy193;
yy430:
		YYDEBUG(430, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy421;
		if (yych == 'l') goto yy421;
		goto yy193;
yy431:
		YYDEBUG(431, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy440;
		if (yych == 'r') goto yy440;
		goto yy193;
yy432:
		YYDEBUG(432, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy433;
		if (yych != 'a') goto yy193;
yy433:
		YYDEBUG(433, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy434;
		if (yych != 'l') goto yy193;
yy434:
		YYDEBUG(434, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy435;
		if (yych != 'a') goto yy193;
yy435:
		YYDEBUG(435, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy436;
		if (yych != 'r') goto yy193;
yy436:
		YYDEBUG(436, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(437, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy436;
			goto yy193;
		} else {
			if (yych <= ' ') goto yy436;
			if (yych != ')') goto yy193;
		}
		YYDEBUG(438, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(439, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1081 "Zend/zend_language_scanner.l"
		{
	return T_SCALAR_CAST;
}
#line 4944 "Zend/zend_language_scanner.c"
yy440:
		YYDEBUG(440, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy441;
		if (yych != 'i') goto yy193;
yy441:
		YYDEBUG(441, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy442;
		if (yych != 'n') goto yy193;
yy442:
		YYDEBUG(442, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy443;
		if (yych != 'g') goto yy193;
yy443:
		YYDEBUG(443, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(444, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy443;
			goto yy193;
		} else {
			if (yych <= ' ') goto yy443;
			if (yych != ')') goto yy193;
		}
		YYDEBUG(445, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(446, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1077 "Zend/zend_language_scanner.l"
		{
	return T_STRING_CAST;
}
#line 4981 "Zend/zend_language_scanner.c"
yy447:
		YYDEBUG(447, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy448;
		if (yych != 'r') goto yy193;
yy448:
		YYDEBUG(448, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy449;
		if (yych != 'a') goto yy193;
yy449:
		YYDEBUG(449, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy450;
		if (yych != 'y') goto yy193;
yy450:
		YYDEBUG(450, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(451, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy450;
			goto yy193;
		} else {
			if (yych <= ' ') goto yy450;
			if (yych != ')') goto yy193;
		}
		YYDEBUG(452, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(453, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1085 "Zend/zend_language_scanner.l"
		{
	return T_ARRAY_CAST;
}
#line 5018 "Zend/zend_language_scanner.c"
yy454:
		YYDEBUG(454, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'J') goto yy455;
		if (yych != 'j') goto yy193;
yy455:
		YYDEBUG(455, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy456;
		if (yych != 'e') goto yy193;
yy456:
		YYDEBUG(456, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy457;
		if (yych != 'c') goto yy193;
yy457:
		YYDEBUG(457, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy458;
		if (yych != 't') goto yy193;
yy458:
		YYDEBUG(458, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(459, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy458;
			goto yy193;
		} else {
			if (yych <= ' ') goto yy458;
			if (yych != ')') goto yy193;
		}
		YYDEBUG(460, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(461, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1089 "Zend/zend_language_scanner.l"
		{
	return T_OBJECT_CAST;
}
#line 5060 "Zend/zend_language_scanner.c"
yy462:
		YYDEBUG(462, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy472;
		if (yych == 'n') goto yy472;
		goto yy193;
yy463:
		YYDEBUG(463, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy464;
		if (yych != 'o') goto yy193;
yy464:
		YYDEBUG(464, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy465;
		if (yych != 'l') goto yy193;
yy465:
		YYDEBUG(465, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy470;
		if (yych == 'e') goto yy470;
		goto yy467;
yy466:
		YYDEBUG(466, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy467:
		YYDEBUG(467, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy466;
			goto yy193;
		} else {
			if (yych <= ' ') goto yy466;
			if (yych != ')') goto yy193;
		}
		YYDEBUG(468, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(469, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1093 "Zend/zend_language_scanner.l"
		{
	return T_BOOL_CAST;
}
#line 5105 "Zend/zend_language_scanner.c"
yy470:
		YYDEBUG(470, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy471;
		if (yych != 'a') goto yy193;
yy471:
		YYDEBUG(471, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy466;
		if (yych == 'n') goto yy466;
		goto yy193;
yy472:
		YYDEBUG(472, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy473;
		if (yych != 'a') goto yy193;
yy473:
		YYDEBUG(473, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy474;
		if (yych != 'r') goto yy193;
yy474:
		YYDEBUG(474, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy443;
		if (yych == 'y') goto yy443;
		goto yy193;
yy475:
		YYDEBUG(475, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy476;
		if (yych != 's') goto yy193;
yy476:
		YYDEBUG(476, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy477;
		if (yych != 'e') goto yy193;
yy477:
		YYDEBUG(477, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy478;
		if (yych != 't') goto yy193;
yy478:
		YYDEBUG(478, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(479, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy478;
			goto yy193;
		} else {
			if (yych <= ' ') goto yy478;
			if (yych != ')') goto yy193;
		}
		YYDEBUG(480, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(481, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1097 "Zend/zend_language_scanner.l"
		{
	return T_UNSET_CAST;
}
#line 5169 "Zend/zend_language_scanner.c"
yy482:
		YYDEBUG(482, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy483;
		if (yych != 'r') goto yy186;
yy483:
		YYDEBUG(483, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(484, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1065 "Zend/zend_language_scanner.l"
		{
	return T_VAR;
}
#line 5187 "Zend/zend_language_scanner.c"
yy485:
		YYDEBUG(485, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy501;
		if (yych == 'm') goto yy501;
		goto yy186;
yy486:
		YYDEBUG(486, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'W') goto yy499;
		if (yych == 'w') goto yy499;
		goto yy186;
yy487:
		YYDEBUG(487, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy488;
		if (yych != 'm') goto yy186;
yy488:
		YYDEBUG(488, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy489;
		if (yych != 'e') goto yy186;
yy489:
		YYDEBUG(489, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy490;
		if (yych != 'r') goto yy186;
yy490:
		YYDEBUG(490, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy491;
		if (yych != 'i') goto yy186;
yy491:
		YYDEBUG(491, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy492;
		if (yych != 'c') goto yy186;
yy492:
		YYDEBUG(492, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy185;
		}
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy124;
				goto yy494;
			} else {
				if (yych == '\r') goto yy494;
				goto yy124;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy494;
				if (yych <= '#') goto yy124;
				goto yy494;
			} else {
				if (yych == '&') goto yy494;
				goto yy124;
			}
		}
yy493:
		YYDEBUG(493, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy494:
		YYDEBUG(494, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				if (yych <= '\t') goto yy493;
			} else {
				if (yych != '\r') goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy493;
				if (yych <= '#') goto yy193;
				goto yy497;
			} else {
				if (yych != '&') goto yy193;
			}
		}
yy495:
		YYDEBUG(495, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(496, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				goto yy495;
			} else {
				if (yych == '\r') goto yy495;
				goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy495;
				if (yych <= '#') goto yy193;
			} else {
				if (yych == '&') goto yy495;
				goto yy193;
			}
		}
yy497:
		YYDEBUG(497, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(498, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1208 "Zend/zend_language_scanner.l"
		{
	yyless(7);
	return T_NUMERIC_HINT;
}
#line 5306 "Zend/zend_language_scanner.c"
yy499:
		YYDEBUG(499, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(500, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1057 "Zend/zend_language_scanner.l"
		{
	return T_NEW;
}
#line 5319 "Zend/zend_language_scanner.c"
yy501:
		YYDEBUG(501, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy502;
		if (yych != 'e') goto yy186;
yy502:
		YYDEBUG(502, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy503;
		if (yych != 's') goto yy186;
yy503:
		YYDEBUG(503, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy504;
		if (yych != 'p') goto yy186;
yy504:
		YYDEBUG(504, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy505;
		if (yych != 'a') goto yy186;
yy505:
		YYDEBUG(505, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy506;
		if (yych != 'c') goto yy186;
yy506:
		YYDEBUG(506, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy507;
		if (yych != 'e') goto yy186;
yy507:
		YYDEBUG(507, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(508, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1121 "Zend/zend_language_scanner.l"
		{
	return T_NAMESPACE;
}
#line 5362 "Zend/zend_language_scanner.c"
yy509:
		YYDEBUG(509, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(510, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1049 "Zend/zend_language_scanner.l"
		{
	return T_PAAMAYIM_NEKUDOTAYIM;
}
#line 5372 "Zend/zend_language_scanner.c"
yy511:
		YYDEBUG(511, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy512:
		YYDEBUG(512, *YYCURSOR);
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy140;
			if (yych <= '\n') goto yy511;
			goto yy140;
		} else {
			if (yych <= '\r') goto yy511;
			if (yych == ' ') goto yy511;
			goto yy140;
		}
yy513:
		YYDEBUG(513, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(514, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1281 "Zend/zend_language_scanner.l"
		{
	return T_MINUS_EQUAL;
}
#line 5398 "Zend/zend_language_scanner.c"
yy515:
		YYDEBUG(515, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(516, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1249 "Zend/zend_language_scanner.l"
		{
	return T_DEC;
}
#line 5408 "Zend/zend_language_scanner.c"
yy517:
		YYDEBUG(517, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(518, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1019 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_PROPERTY TSRMLS_CC);
	return T_OBJECT_OPERATOR;
}
#line 5419 "Zend/zend_language_scanner.c"
yy519:
		YYDEBUG(519, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'I') goto yy526;
			if (yych <= 'N') goto yy186;
			goto yy527;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy186;
				goto yy526;
			} else {
				if (yych == 'o') goto yy527;
				goto yy186;
			}
		}
yy520:
		YYDEBUG(520, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy521;
		if (yych != 'b') goto yy186;
yy521:
		YYDEBUG(521, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy522;
		if (yych != 'l') goto yy186;
yy522:
		YYDEBUG(522, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy523;
		if (yych != 'i') goto yy186;
yy523:
		YYDEBUG(523, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy524;
		if (yych != 'c') goto yy186;
yy524:
		YYDEBUG(524, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(525, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1169 "Zend/zend_language_scanner.l"
		{
	return T_PUBLIC;
}
#line 5468 "Zend/zend_language_scanner.c"
yy526:
		YYDEBUG(526, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'V') {
			if (yych == 'N') goto yy535;
			if (yych <= 'U') goto yy186;
			goto yy536;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy186;
				goto yy535;
			} else {
				if (yych == 'v') goto yy536;
				goto yy186;
			}
		}
yy527:
		YYDEBUG(527, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy528;
		if (yych != 't') goto yy186;
yy528:
		YYDEBUG(528, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy529;
		if (yych != 'e') goto yy186;
yy529:
		YYDEBUG(529, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy530;
		if (yych != 'c') goto yy186;
yy530:
		YYDEBUG(530, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy531;
		if (yych != 't') goto yy186;
yy531:
		YYDEBUG(531, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy532;
		if (yych != 'e') goto yy186;
yy532:
		YYDEBUG(532, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy533;
		if (yych != 'd') goto yy186;
yy533:
		YYDEBUG(533, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(534, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1165 "Zend/zend_language_scanner.l"
		{
	return T_PROTECTED;
}
#line 5527 "Zend/zend_language_scanner.c"
yy535:
		YYDEBUG(535, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy541;
		if (yych == 't') goto yy541;
		goto yy186;
yy536:
		YYDEBUG(536, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy537;
		if (yych != 'a') goto yy186;
yy537:
		YYDEBUG(537, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy538;
		if (yych != 't') goto yy186;
yy538:
		YYDEBUG(538, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy539;
		if (yych != 'e') goto yy186;
yy539:
		YYDEBUG(539, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(540, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1161 "Zend/zend_language_scanner.l"
		{
	return T_PRIVATE;
}
#line 5561 "Zend/zend_language_scanner.c"
yy541:
		YYDEBUG(541, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(542, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 995 "Zend/zend_language_scanner.l"
		{
	return T_PRINT;
}
#line 5574 "Zend/zend_language_scanner.c"
yy543:
		YYDEBUG(543, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy548;
		if (yych == 'o') goto yy548;
		goto yy186;
yy544:
		YYDEBUG(544, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy545;
		if (yych != 't') goto yy186;
yy545:
		YYDEBUG(545, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy546;
		if (yych != 'o') goto yy186;
yy546:
		YYDEBUG(546, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(547, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 987 "Zend/zend_language_scanner.l"
		{
	return T_GOTO;
}
#line 5603 "Zend/zend_language_scanner.c"
yy548:
		YYDEBUG(548, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy549;
		if (yych != 'b') goto yy186;
yy549:
		YYDEBUG(549, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy550;
		if (yych != 'a') goto yy186;
yy550:
		YYDEBUG(550, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy551;
		if (yych != 'l') goto yy186;
yy551:
		YYDEBUG(551, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(552, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1133 "Zend/zend_language_scanner.l"
		{
	return T_GLOBAL;
}
#line 5631 "Zend/zend_language_scanner.c"
yy553:
		YYDEBUG(553, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy584;
		goto yy193;
yy554:
		YYDEBUG(554, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy180;
yy555:
		YYDEBUG(555, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy178;
yy556:
		YYDEBUG(556, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy574;
		if (yych == 'n') goto yy574;
		goto yy186;
yy557:
		YYDEBUG(557, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy563;
		if (yych == 'o') goto yy563;
		goto yy186;
yy558:
		YYDEBUG(558, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy559;
		if (yych != 'e') goto yy186;
yy559:
		YYDEBUG(559, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy560;
		if (yych != 'a') goto yy186;
yy560:
		YYDEBUG(560, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'K') goto yy561;
		if (yych != 'k') goto yy186;
yy561:
		YYDEBUG(561, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(562, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 979 "Zend/zend_language_scanner.l"
		{
	return T_BREAK;
}
#line 5684 "Zend/zend_language_scanner.c"
yy563:
		YYDEBUG(563, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy564;
		if (yych != 'l') goto yy186;
yy564:
		YYDEBUG(564, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '9') {
			if (yych <= ' ') {
				if (yych <= '\f') {
					if (yych <= 0x08) goto yy124;
					if (yych <= '\n') goto yy566;
					goto yy124;
				} else {
					if (yych <= '\r') goto yy566;
					if (yych <= 0x1F) goto yy124;
					goto yy566;
				}
			} else {
				if (yych <= '%') {
					if (yych == '$') goto yy566;
					goto yy124;
				} else {
					if (yych <= '&') goto yy566;
					if (yych <= '/') goto yy124;
					goto yy185;
				}
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'E') {
					if (yych <= '@') goto yy124;
					if (yych <= 'D') goto yy185;
					goto yy571;
				} else {
					if (yych <= 'Z') goto yy185;
					if (yych <= '^') goto yy124;
					goto yy185;
				}
			} else {
				if (yych <= 'e') {
					if (yych <= '`') goto yy124;
					if (yych <= 'd') goto yy185;
					goto yy571;
				} else {
					if (yych <= 'z') goto yy185;
					if (yych <= '~') goto yy124;
					goto yy185;
				}
			}
		}
yy565:
		YYDEBUG(565, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy566:
		YYDEBUG(566, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				if (yych <= '\t') goto yy565;
			} else {
				if (yych != '\r') goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy565;
				if (yych <= '#') goto yy193;
				goto yy569;
			} else {
				if (yych != '&') goto yy193;
			}
		}
yy567:
		YYDEBUG(567, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(568, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				goto yy567;
			} else {
				if (yych == '\r') goto yy567;
				goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy567;
				if (yych <= '#') goto yy193;
			} else {
				if (yych == '&') goto yy567;
				goto yy193;
			}
		}
yy569:
		YYDEBUG(569, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(570, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1189 "Zend/zend_language_scanner.l"
		{
	if (yytext[4] == 'e') {
		yyless((sizeof("boolean") - 1));
	} else {
		yyless((sizeof("bool") - 1));
	}
	return T_BOOL_HINT;
}
#line 5798 "Zend/zend_language_scanner.c"
yy571:
		YYDEBUG(571, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy572;
		if (yych != 'a') goto yy186;
yy572:
		YYDEBUG(572, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy573;
		if (yych != 'n') goto yy186;
yy573:
		YYDEBUG(573, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy185;
		}
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy124;
				goto yy566;
			} else {
				if (yych == '\r') goto yy566;
				goto yy124;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy566;
				if (yych <= '#') goto yy124;
				goto yy566;
			} else {
				if (yych == '&') goto yy566;
				goto yy124;
			}
		}
yy574:
		YYDEBUG(574, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy575;
		if (yych != 'a') goto yy186;
yy575:
		YYDEBUG(575, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy576;
		if (yych != 'r') goto yy186;
yy576:
		YYDEBUG(576, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy577;
		if (yych != 'y') goto yy186;
yy577:
		YYDEBUG(577, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy185;
		}
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy124;
				goto yy579;
			} else {
				if (yych == '\r') goto yy579;
				goto yy124;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy579;
				if (yych <= '#') goto yy124;
				goto yy579;
			} else {
				if (yych == '&') goto yy579;
				goto yy124;
			}
		}
yy578:
		YYDEBUG(578, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy579:
		YYDEBUG(579, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				if (yych <= '\t') goto yy578;
			} else {
				if (yych != '\r') goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy578;
				if (yych <= '#') goto yy193;
				goto yy582;
			} else {
				if (yych != '&') goto yy193;
			}
		}
yy580:
		YYDEBUG(580, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(581, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				goto yy580;
			} else {
				if (yych == '\r') goto yy580;
				goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy580;
				if (yych <= '#') goto yy193;
			} else {
				if (yych == '&') goto yy580;
				goto yy193;
			}
		}
yy582:
		YYDEBUG(582, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(583, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1198 "Zend/zend_language_scanner.l"
		{
	yyless(6);
	return T_STRING_HINT;
}
#line 5930 "Zend/zend_language_scanner.c"
yy584:
		YYDEBUG(584, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy263;
		goto yy193;
yy585:
		YYDEBUG(585, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy601;
		if (yych == 'a') goto yy601;
		goto yy186;
yy586:
		YYDEBUG(586, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'R') {
			if (yych == 'A') goto yy593;
			if (yych <= 'Q') goto yy186;
			goto yy594;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy186;
				goto yy593;
			} else {
				if (yych == 'r') goto yy594;
				goto yy186;
			}
		}
yy587:
		YYDEBUG(587, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy588;
		if (yych != 'i') goto yy186;
yy588:
		YYDEBUG(588, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy589;
		if (yych != 't') goto yy186;
yy589:
		YYDEBUG(589, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy590;
		if (yych != 'c') goto yy186;
yy590:
		YYDEBUG(590, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy591;
		if (yych != 'h') goto yy186;
yy591:
		YYDEBUG(591, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(592, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 963 "Zend/zend_language_scanner.l"
		{
	return T_SWITCH;
}
#line 5990 "Zend/zend_language_scanner.c"
yy593:
		YYDEBUG(593, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy597;
		if (yych == 't') goto yy597;
		goto yy186;
yy594:
		YYDEBUG(594, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy595;
		if (yych != 'i') goto yy186;
yy595:
		YYDEBUG(595, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy596;
		if (yych != 'n') goto yy186;
yy596:
		YYDEBUG(596, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy577;
		if (yych == 'g') goto yy577;
		goto yy186;
yy597:
		YYDEBUG(597, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy598;
		if (yych != 'i') goto yy186;
yy598:
		YYDEBUG(598, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy599;
		if (yych != 'c') goto yy186;
yy599:
		YYDEBUG(599, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(600, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1149 "Zend/zend_language_scanner.l"
		{
	return T_STATIC;
}
#line 6035 "Zend/zend_language_scanner.c"
yy601:
		YYDEBUG(601, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy602;
		if (yych != 'l') goto yy186;
yy602:
		YYDEBUG(602, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy603;
		if (yych != 'a') goto yy186;
yy603:
		YYDEBUG(603, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy604;
		if (yych != 'r') goto yy186;
yy604:
		YYDEBUG(604, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy185;
		}
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy124;
				goto yy606;
			} else {
				if (yych == '\r') goto yy606;
				goto yy124;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy606;
				if (yych <= '#') goto yy124;
				goto yy606;
			} else {
				if (yych == '&') goto yy606;
				goto yy124;
			}
		}
yy605:
		YYDEBUG(605, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy606:
		YYDEBUG(606, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				if (yych <= '\t') goto yy605;
			} else {
				if (yych != '\r') goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy605;
				if (yych <= '#') goto yy193;
				goto yy609;
			} else {
				if (yych != '&') goto yy193;
			}
		}
yy607:
		YYDEBUG(607, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(608, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				goto yy607;
			} else {
				if (yych == '\r') goto yy607;
				goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy607;
				if (yych <= '#') goto yy193;
			} else {
				if (yych == '&') goto yy607;
				goto yy193;
			}
		}
yy609:
		YYDEBUG(609, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(610, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1203 "Zend/zend_language_scanner.l"
		{
	yyless(6);
	return T_SCALAR_HINT;
}
#line 6132 "Zend/zend_language_scanner.c"
yy611:
		YYDEBUG(611, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy622;
		if (yych == 's') goto yy622;
		goto yy186;
yy612:
		YYDEBUG(612, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy620;
		if (yych == 'd') goto yy620;
		goto yy186;
yy613:
		YYDEBUG(613, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy616;
		if (yych == 'r') goto yy616;
		goto yy186;
yy614:
		YYDEBUG(614, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(615, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 959 "Zend/zend_language_scanner.l"
		{
	return T_AS;
}
#line 6163 "Zend/zend_language_scanner.c"
yy616:
		YYDEBUG(616, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy617;
		if (yych != 'a') goto yy186;
yy617:
		YYDEBUG(617, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy618;
		if (yych != 'y') goto yy186;
yy618:
		YYDEBUG(618, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(619, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1185 "Zend/zend_language_scanner.l"
		{
	return T_ARRAY;
}
#line 6186 "Zend/zend_language_scanner.c"
yy620:
		YYDEBUG(620, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(621, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1333 "Zend/zend_language_scanner.l"
		{
	return T_LOGICAL_AND;
}
#line 6199 "Zend/zend_language_scanner.c"
yy622:
		YYDEBUG(622, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy623;
		if (yych != 't') goto yy186;
yy623:
		YYDEBUG(623, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy624;
		if (yych != 'r') goto yy186;
yy624:
		YYDEBUG(624, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy625;
		if (yych != 'a') goto yy186;
yy625:
		YYDEBUG(625, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy626;
		if (yych != 'c') goto yy186;
yy626:
		YYDEBUG(626, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy627;
		if (yych != 't') goto yy186;
yy627:
		YYDEBUG(627, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(628, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1153 "Zend/zend_language_scanner.l"
		{
	return T_ABSTRACT;
}
#line 6237 "Zend/zend_language_scanner.c"
yy629:
		YYDEBUG(629, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy630;
		if (yych != 'i') goto yy186;
yy630:
		YYDEBUG(630, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy631;
		if (yych != 'l') goto yy186;
yy631:
		YYDEBUG(631, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy632;
		if (yych != 'e') goto yy186;
yy632:
		YYDEBUG(632, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(633, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 919 "Zend/zend_language_scanner.l"
		{
	return T_WHILE;
}
#line 6265 "Zend/zend_language_scanner.c"
yy634:
		YYDEBUG(634, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(635, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 903 "Zend/zend_language_scanner.l"
		{
	return T_IF;
}
#line 6278 "Zend/zend_language_scanner.c"
yy636:
		YYDEBUG(636, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy680;
		if (yych == 'p') goto yy680;
		goto yy186;
yy637:
		YYDEBUG(637, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych <= 'C') {
				if (yych <= 'B') goto yy186;
				goto yy645;
			} else {
				if (yych <= 'R') goto yy186;
				if (yych <= 'S') goto yy643;
				goto yy644;
			}
		} else {
			if (yych <= 'r') {
				if (yych == 'c') goto yy645;
				goto yy186;
			} else {
				if (yych <= 's') goto yy643;
				if (yych <= 't') goto yy644;
				goto yy186;
			}
		}
yy638:
		YYDEBUG(638, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy639;
		if (yych != 's') goto yy186;
yy639:
		YYDEBUG(639, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy640;
		if (yych != 'e') goto yy186;
yy640:
		YYDEBUG(640, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy641;
		if (yych != 't') goto yy186;
yy641:
		YYDEBUG(641, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(642, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1137 "Zend/zend_language_scanner.l"
		{
	return T_ISSET;
}
#line 6334 "Zend/zend_language_scanner.c"
yy643:
		YYDEBUG(643, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy666;
		if (yych == 't') goto yy666;
		goto yy186;
yy644:
		YYDEBUG(644, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '9') {
			if (yych <= ' ') {
				if (yych <= '\f') {
					if (yych <= 0x08) goto yy124;
					if (yych <= '\n') goto yy302;
					goto yy124;
				} else {
					if (yych <= '\r') goto yy302;
					if (yych <= 0x1F) goto yy124;
					goto yy302;
				}
			} else {
				if (yych <= '%') {
					if (yych == '$') goto yy302;
					goto yy124;
				} else {
					if (yych <= '&') goto yy302;
					if (yych <= '/') goto yy124;
					goto yy185;
				}
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'E') {
					if (yych <= '@') goto yy124;
					if (yych <= 'D') goto yy185;
					goto yy657;
				} else {
					if (yych <= 'Z') goto yy185;
					if (yych <= '^') goto yy124;
					goto yy185;
				}
			} else {
				if (yych <= 'e') {
					if (yych <= '`') goto yy124;
					if (yych <= 'd') goto yy185;
					goto yy657;
				} else {
					if (yych <= 'z') goto yy185;
					if (yych <= '~') goto yy124;
					goto yy185;
				}
			}
		}
yy645:
		YYDEBUG(645, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy646;
		if (yych != 'l') goto yy186;
yy646:
		YYDEBUG(646, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy647;
		if (yych != 'u') goto yy186;
yy647:
		YYDEBUG(647, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy648;
		if (yych != 'd') goto yy186;
yy648:
		YYDEBUG(648, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy649;
		if (yych != 'e') goto yy186;
yy649:
		YYDEBUG(649, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy185;
			} else {
				if (yych <= '@') goto yy650;
				if (yych <= 'Z') goto yy185;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy651;
			} else {
				if (yych <= 'z') goto yy185;
				if (yych >= 0x7F) goto yy185;
			}
		}
yy650:
		YYDEBUG(650, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1105 "Zend/zend_language_scanner.l"
		{
	return T_INCLUDE;
}
#line 6434 "Zend/zend_language_scanner.c"
yy651:
		YYDEBUG(651, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy652;
		if (yych != 'o') goto yy186;
yy652:
		YYDEBUG(652, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy653;
		if (yych != 'n') goto yy186;
yy653:
		YYDEBUG(653, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy654;
		if (yych != 'c') goto yy186;
yy654:
		YYDEBUG(654, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy655;
		if (yych != 'e') goto yy186;
yy655:
		YYDEBUG(655, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(656, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1109 "Zend/zend_language_scanner.l"
		{
	return T_INCLUDE_ONCE;
}
#line 6467 "Zend/zend_language_scanner.c"
yy657:
		YYDEBUG(657, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'R') {
			if (yych == 'G') goto yy659;
			if (yych <= 'Q') goto yy186;
		} else {
			if (yych <= 'g') {
				if (yych <= 'f') goto yy186;
				goto yy659;
			} else {
				if (yych != 'r') goto yy186;
			}
		}
		YYDEBUG(658, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy661;
		if (yych == 'f') goto yy661;
		goto yy186;
yy659:
		YYDEBUG(659, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy660;
		if (yych != 'e') goto yy186;
yy660:
		YYDEBUG(660, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy300;
		if (yych == 'r') goto yy300;
		goto yy186;
yy661:
		YYDEBUG(661, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy662;
		if (yych != 'a') goto yy186;
yy662:
		YYDEBUG(662, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy663;
		if (yych != 'c') goto yy186;
yy663:
		YYDEBUG(663, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy664;
		if (yych != 'e') goto yy186;
yy664:
		YYDEBUG(664, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(665, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1003 "Zend/zend_language_scanner.l"
		{
	return T_INTERFACE;
}
#line 6525 "Zend/zend_language_scanner.c"
yy666:
		YYDEBUG(666, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'E') {
			if (yych == 'A') goto yy667;
			if (yych <= 'D') goto yy186;
			goto yy668;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy186;
			} else {
				if (yych == 'e') goto yy668;
				goto yy186;
			}
		}
yy667:
		YYDEBUG(667, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy674;
		if (yych == 'n') goto yy674;
		goto yy186;
yy668:
		YYDEBUG(668, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy669;
		if (yych != 'a') goto yy186;
yy669:
		YYDEBUG(669, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy670;
		if (yych != 'd') goto yy186;
yy670:
		YYDEBUG(670, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy671;
		if (yych != 'o') goto yy186;
yy671:
		YYDEBUG(671, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy672;
		if (yych != 'f') goto yy186;
yy672:
		YYDEBUG(672, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(673, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1129 "Zend/zend_language_scanner.l"
		{
        return T_INSTEADOF;
}
#line 6579 "Zend/zend_language_scanner.c"
yy674:
		YYDEBUG(674, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy675;
		if (yych != 'c') goto yy186;
yy675:
		YYDEBUG(675, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy676;
		if (yych != 'e') goto yy186;
yy676:
		YYDEBUG(676, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy677;
		if (yych != 'o') goto yy186;
yy677:
		YYDEBUG(677, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy678;
		if (yych != 'f') goto yy186;
yy678:
		YYDEBUG(678, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(679, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 955 "Zend/zend_language_scanner.l"
		{
	return T_INSTANCEOF;
}
#line 6612 "Zend/zend_language_scanner.c"
yy680:
		YYDEBUG(680, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy681;
		if (yych != 'l') goto yy186;
yy681:
		YYDEBUG(681, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy682;
		if (yych != 'e') goto yy186;
yy682:
		YYDEBUG(682, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy683;
		if (yych != 'm') goto yy186;
yy683:
		YYDEBUG(683, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy684;
		if (yych != 'e') goto yy186;
yy684:
		YYDEBUG(684, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy685;
		if (yych != 'n') goto yy186;
yy685:
		YYDEBUG(685, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy686;
		if (yych != 't') goto yy186;
yy686:
		YYDEBUG(686, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy687;
		if (yych != 's') goto yy186;
yy687:
		YYDEBUG(687, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(688, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1015 "Zend/zend_language_scanner.l"
		{
	return T_IMPLEMENTS;
}
#line 6660 "Zend/zend_language_scanner.c"
yy689:
		YYDEBUG(689, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy697;
		if (yych == 'r') goto yy697;
		goto yy186;
yy690:
		YYDEBUG(690, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'Y') {
			if (yych == 'A') goto yy693;
			if (yych <= 'X') goto yy186;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy186;
				goto yy693;
			} else {
				if (yych != 'y') goto yy186;
			}
		}
		YYDEBUG(691, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(692, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 891 "Zend/zend_language_scanner.l"
		{
	return T_TRY;
}
#line 6692 "Zend/zend_language_scanner.c"
yy693:
		YYDEBUG(693, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy694;
		if (yych != 'i') goto yy186;
yy694:
		YYDEBUG(694, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy695;
		if (yych != 't') goto yy186;
yy695:
		YYDEBUG(695, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(696, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1007 "Zend/zend_language_scanner.l"
		{
	return T_TRAIT;
}
#line 6715 "Zend/zend_language_scanner.c"
yy697:
		YYDEBUG(697, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy698;
		if (yych != 'o') goto yy186;
yy698:
		YYDEBUG(698, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'W') goto yy699;
		if (yych != 'w') goto yy186;
yy699:
		YYDEBUG(699, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(700, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 899 "Zend/zend_language_scanner.l"
		{
	return T_THROW;
}
#line 6738 "Zend/zend_language_scanner.c"
yy701:
		YYDEBUG(701, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych <= 'P') {
				if (yych == 'A') goto yy704;
				goto yy186;
			} else {
				if (yych <= 'Q') goto yy703;
				if (yych <= 'R') goto yy186;
				if (yych <= 'S') goto yy705;
			}
		} else {
			if (yych <= 'q') {
				if (yych == 'a') goto yy704;
				if (yych <= 'p') goto yy186;
				goto yy703;
			} else {
				if (yych <= 'r') goto yy186;
				if (yych <= 's') goto yy705;
				if (yych >= 'u') goto yy186;
			}
		}
		YYDEBUG(702, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy735;
		if (yych == 'u') goto yy735;
		goto yy186;
yy703:
		YYDEBUG(703, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy724;
		if (yych == 'u') goto yy724;
		goto yy186;
yy704:
		YYDEBUG(704, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy717;
		if (yych == 'l') goto yy717;
		goto yy186;
yy705:
		YYDEBUG(705, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy706;
		if (yych != 'o') goto yy186;
yy706:
		YYDEBUG(706, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy707;
		if (yych != 'u') goto yy186;
yy707:
		YYDEBUG(707, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy708;
		if (yych != 'r') goto yy186;
yy708:
		YYDEBUG(708, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy709;
		if (yych != 'c') goto yy186;
yy709:
		YYDEBUG(709, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy710;
		if (yych != 'e') goto yy186;
yy710:
		YYDEBUG(710, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy185;
		}
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy124;
				goto yy712;
			} else {
				if (yych == '\r') goto yy712;
				goto yy124;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy712;
				if (yych <= '#') goto yy124;
				goto yy712;
			} else {
				if (yych == '&') goto yy712;
				goto yy124;
			}
		}
yy711:
		YYDEBUG(711, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy712:
		YYDEBUG(712, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				if (yych <= '\t') goto yy711;
			} else {
				if (yych != '\r') goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy711;
				if (yych <= '#') goto yy193;
				goto yy715;
			} else {
				if (yych != '&') goto yy193;
			}
		}
yy713:
		YYDEBUG(713, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(714, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				goto yy713;
			} else {
				if (yych == '\r') goto yy713;
				goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy713;
				if (yych <= '#') goto yy193;
			} else {
				if (yych == '&') goto yy713;
				goto yy193;
			}
		}
yy715:
		YYDEBUG(715, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(716, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1235 "Zend/zend_language_scanner.l"
		{
	yyless((sizeof("resource") - 1));
	return T_RESOURCE_HINT;
}
#line 6885 "Zend/zend_language_scanner.c"
yy717:
		YYDEBUG(717, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy185;
		}
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy124;
				goto yy719;
			} else {
				if (yych == '\r') goto yy719;
				goto yy124;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy719;
				if (yych <= '#') goto yy124;
				goto yy719;
			} else {
				if (yych == '&') goto yy719;
				goto yy124;
			}
		}
yy718:
		YYDEBUG(718, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy719:
		YYDEBUG(719, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				if (yych <= '\t') goto yy718;
			} else {
				if (yych != '\r') goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy718;
				if (yych <= '#') goto yy193;
				goto yy722;
			} else {
				if (yych != '&') goto yy193;
			}
		}
yy720:
		YYDEBUG(720, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(721, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy193;
				goto yy720;
			} else {
				if (yych == '\r') goto yy720;
				goto yy193;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy720;
				if (yych <= '#') goto yy193;
			} else {
				if (yych == '&') goto yy720;
				goto yy193;
			}
		}
yy722:
		YYDEBUG(722, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(723, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1224 "Zend/zend_language_scanner.l"
		{
	if (yytext[4] == 'l') {
		yyless((sizeof("double") - 1));
	} else 	if (yytext[4] == 't') {
		yyless((sizeof("float") - 1));
	} else {
		yyless(4);
	}
	return T_DOUBLE_HINT;
}
#line 6973 "Zend/zend_language_scanner.c"
yy724:
		YYDEBUG(724, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy725;
		if (yych != 'i') goto yy186;
yy725:
		YYDEBUG(725, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy726;
		if (yych != 'r') goto yy186;
yy726:
		YYDEBUG(726, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy727;
		if (yych != 'e') goto yy186;
yy727:
		YYDEBUG(727, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy185;
			} else {
				if (yych <= '@') goto yy728;
				if (yych <= 'Z') goto yy185;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy729;
			} else {
				if (yych <= 'z') goto yy185;
				if (yych >= 0x7F) goto yy185;
			}
		}
yy728:
		YYDEBUG(728, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1113 "Zend/zend_language_scanner.l"
		{
	return T_REQUIRE;
}
#line 7014 "Zend/zend_language_scanner.c"
yy729:
		YYDEBUG(729, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy730;
		if (yych != 'o') goto yy186;
yy730:
		YYDEBUG(730, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy731;
		if (yych != 'n') goto yy186;
yy731:
		YYDEBUG(731, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy732;
		if (yych != 'c') goto yy186;
yy732:
		YYDEBUG(732, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy733;
		if (yych != 'e') goto yy186;
yy733:
		YYDEBUG(733, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(734, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1117 "Zend/zend_language_scanner.l"
		{
	return T_REQUIRE_ONCE;
}
#line 7047 "Zend/zend_language_scanner.c"
yy735:
		YYDEBUG(735, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy736;
		if (yych != 'r') goto yy186;
yy736:
		YYDEBUG(736, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy737;
		if (yych != 'n') goto yy186;
yy737:
		YYDEBUG(737, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(738, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 887 "Zend/zend_language_scanner.l"
		{
	return T_RETURN;
}
#line 7070 "Zend/zend_language_scanner.c"
yy739:
		YYDEBUG(739, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych <= 'R') goto yy186;
			if (yych <= 'S') goto yy761;
			goto yy760;
		} else {
			if (yych <= 'r') goto yy186;
			if (yych <= 's') goto yy761;
			if (yych <= 't') goto yy760;
			goto yy186;
		}
yy740:
		YYDEBUG(740, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'A') goto yy752;
			if (yych <= 'N') goto yy186;
			goto yy753;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy186;
				goto yy752;
			} else {
				if (yych == 'o') goto yy753;
				goto yy186;
			}
		}
yy741:
		YYDEBUG(741, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy742;
		if (yych != 'n') goto yy186;
yy742:
		YYDEBUG(742, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych <= 'R') goto yy186;
			if (yych >= 'T') goto yy744;
		} else {
			if (yych <= 'r') goto yy186;
			if (yych <= 's') goto yy743;
			if (yych <= 't') goto yy744;
			goto yy186;
		}
yy743:
		YYDEBUG(743, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy750;
		if (yych == 't') goto yy750;
		goto yy186;
yy744:
		YYDEBUG(744, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy745;
		if (yych != 'i') goto yy186;
yy745:
		YYDEBUG(745, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy746;
		if (yych != 'n') goto yy186;
yy746:
		YYDEBUG(746, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy747;
		if (yych != 'u') goto yy186;
yy747:
		YYDEBUG(747, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy748;
		if (yych != 'e') goto yy186;
yy748:
		YYDEBUG(748, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(749, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 983 "Zend/zend_language_scanner.l"
		{
	return T_CONTINUE;
}
#line 7155 "Zend/zend_language_scanner.c"
yy750:
		YYDEBUG(750, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(751, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 883 "Zend/zend_language_scanner.l"
		{
	return T_CONST;
}
#line 7168 "Zend/zend_language_scanner.c"
yy752:
		YYDEBUG(752, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy757;
		if (yych == 's') goto yy757;
		goto yy186;
yy753:
		YYDEBUG(753, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy754;
		if (yych != 'n') goto yy186;
yy754:
		YYDEBUG(754, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy755;
		if (yych != 'e') goto yy186;
yy755:
		YYDEBUG(755, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(756, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1061 "Zend/zend_language_scanner.l"
		{
	return T_CLONE;
}
#line 7197 "Zend/zend_language_scanner.c"
yy757:
		YYDEBUG(757, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy758;
		if (yych != 's') goto yy186;
yy758:
		YYDEBUG(758, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(759, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 999 "Zend/zend_language_scanner.l"
		{
	return T_CLASS;
}
#line 7215 "Zend/zend_language_scanner.c"
yy760:
		YYDEBUG(760, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy764;
		if (yych == 'c') goto yy764;
		goto yy186;
yy761:
		YYDEBUG(761, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy762;
		if (yych != 'e') goto yy186;
yy762:
		YYDEBUG(762, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(763, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 971 "Zend/zend_language_scanner.l"
		{
	return T_CASE;
}
#line 7239 "Zend/zend_language_scanner.c"
yy764:
		YYDEBUG(764, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy765;
		if (yych != 'h') goto yy186;
yy765:
		YYDEBUG(765, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(766, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 895 "Zend/zend_language_scanner.l"
		{
	return T_CATCH;
}
#line 7257 "Zend/zend_language_scanner.c"
yy767:
		YYDEBUG(767, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy787;
		if (yych == 'n') goto yy787;
		goto yy186;
yy768:
		YYDEBUG(768, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy785;
		if (yych == 'o') goto yy785;
		goto yy186;
yy769:
		YYDEBUG(769, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy778;
		if (yych == 'r') goto yy778;
		goto yy186;
yy770:
		YYDEBUG(770, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy771;
		if (yych != 'n') goto yy186;
yy771:
		YYDEBUG(771, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy772;
		if (yych != 'c') goto yy186;
yy772:
		YYDEBUG(772, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy773;
		if (yych != 't') goto yy186;
yy773:
		YYDEBUG(773, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy774;
		if (yych != 'i') goto yy186;
yy774:
		YYDEBUG(774, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy775;
		if (yych != 'o') goto yy186;
yy775:
		YYDEBUG(775, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy776;
		if (yych != 'n') goto yy186;
yy776:
		YYDEBUG(776, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(777, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 879 "Zend/zend_language_scanner.l"
		{
	return T_FUNCTION;
}
#line 7318 "Zend/zend_language_scanner.c"
yy778:
		YYDEBUG(778, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '@') {
				if (yych <= '/') goto yy779;
				if (yych <= '9') goto yy185;
			} else {
				if (yych == 'E') goto yy780;
				if (yych <= 'Z') goto yy185;
			}
		} else {
			if (yych <= 'd') {
				if (yych != '`') goto yy185;
			} else {
				if (yych <= 'e') goto yy780;
				if (yych <= 'z') goto yy185;
				if (yych >= 0x7F) goto yy185;
			}
		}
yy779:
		YYDEBUG(779, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 931 "Zend/zend_language_scanner.l"
		{
	return T_FOR;
}
#line 7346 "Zend/zend_language_scanner.c"
yy780:
		YYDEBUG(780, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy781;
		if (yych != 'a') goto yy186;
yy781:
		YYDEBUG(781, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy782;
		if (yych != 'c') goto yy186;
yy782:
		YYDEBUG(782, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy783;
		if (yych != 'h') goto yy186;
yy783:
		YYDEBUG(783, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(784, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 939 "Zend/zend_language_scanner.l"
		{
	return T_FOREACH;
}
#line 7374 "Zend/zend_language_scanner.c"
yy785:
		YYDEBUG(785, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy786;
		if (yych != 'a') goto yy186;
yy786:
		YYDEBUG(786, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy717;
		if (yych == 't') goto yy717;
		goto yy186;
yy787:
		YYDEBUG(787, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy788;
		if (yych != 'a') goto yy186;
yy788:
		YYDEBUG(788, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy789;
		if (yych != 'l') goto yy186;
yy789:
		YYDEBUG(789, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(790, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1157 "Zend/zend_language_scanner.l"
		{
	return T_FINAL;
}
#line 7408 "Zend/zend_language_scanner.c"
yy791:
		YYDEBUG(791, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'F') {
			if (yych == 'C') goto yy800;
			if (yych <= 'E') goto yy186;
			goto yy801;
		} else {
			if (yych <= 'c') {
				if (yych <= 'b') goto yy186;
				goto yy800;
			} else {
				if (yych == 'f') goto yy801;
				goto yy186;
			}
		}
yy792:
		YYDEBUG(792, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy798;
		if (yych == 'e') goto yy798;
		goto yy186;
yy793:
		YYDEBUG(793, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '@') {
				if (yych <= '/') goto yy794;
				if (yych <= '9') goto yy185;
			} else {
				if (yych == 'U') goto yy795;
				if (yych <= 'Z') goto yy185;
			}
		} else {
			if (yych <= 't') {
				if (yych != '`') goto yy185;
			} else {
				if (yych <= 'u') goto yy795;
				if (yych <= 'z') goto yy185;
				if (yych >= 0x7F) goto yy185;
			}
		}
yy794:
		YYDEBUG(794, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 927 "Zend/zend_language_scanner.l"
		{
	return T_DO;
}
#line 7458 "Zend/zend_language_scanner.c"
yy795:
		YYDEBUG(795, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy796;
		if (yych != 'b') goto yy186;
yy796:
		YYDEBUG(796, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy797;
		if (yych != 'l') goto yy186;
yy797:
		YYDEBUG(797, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy717;
		if (yych == 'e') goto yy717;
		goto yy186;
yy798:
		YYDEBUG(798, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(799, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 875 "Zend/zend_language_scanner.l"
		{
	return T_EXIT;
}
#line 7487 "Zend/zend_language_scanner.c"
yy800:
		YYDEBUG(800, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy807;
		if (yych == 'l') goto yy807;
		goto yy186;
yy801:
		YYDEBUG(801, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy802;
		if (yych != 'a') goto yy186;
yy802:
		YYDEBUG(802, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy803;
		if (yych != 'u') goto yy186;
yy803:
		YYDEBUG(803, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy804;
		if (yych != 'l') goto yy186;
yy804:
		YYDEBUG(804, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy805;
		if (yych != 't') goto yy186;
yy805:
		YYDEBUG(805, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(806, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 975 "Zend/zend_language_scanner.l"
		{
	return T_DEFAULT;
}
#line 7526 "Zend/zend_language_scanner.c"
yy807:
		YYDEBUG(807, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy808;
		if (yych != 'a') goto yy186;
yy808:
		YYDEBUG(808, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy809;
		if (yych != 'r') goto yy186;
yy809:
		YYDEBUG(809, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy810;
		if (yych != 'e') goto yy186;
yy810:
		YYDEBUG(810, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(811, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 947 "Zend/zend_language_scanner.l"
		{
	return T_DECLARE;
}
#line 7554 "Zend/zend_language_scanner.c"
yy812:
		YYDEBUG(812, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy874;
		if (yych == 'h') goto yy874;
		goto yy186;
yy813:
		YYDEBUG(813, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy868;
		if (yych == 's') goto yy868;
		goto yy186;
yy814:
		YYDEBUG(814, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy864;
		if (yych == 'p') goto yy864;
		goto yy186;
yy815:
		YYDEBUG(815, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy830;
		if (yych == 'd') goto yy830;
		goto yy186;
yy816:
		YYDEBUG(816, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy827;
		if (yych == 'a') goto yy827;
		goto yy186;
yy817:
		YYDEBUG(817, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'T') {
			if (yych == 'I') goto yy818;
			if (yych <= 'S') goto yy186;
			goto yy819;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy186;
			} else {
				if (yych == 't') goto yy819;
				goto yy186;
			}
		}
yy818:
		YYDEBUG(818, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy825;
		if (yych == 't') goto yy825;
		goto yy186;
yy819:
		YYDEBUG(819, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy820;
		if (yych != 'e') goto yy186;
yy820:
		YYDEBUG(820, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy821;
		if (yych != 'n') goto yy186;
yy821:
		YYDEBUG(821, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy822;
		if (yych != 'd') goto yy186;
yy822:
		YYDEBUG(822, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy823;
		if (yych != 's') goto yy186;
yy823:
		YYDEBUG(823, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(824, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1011 "Zend/zend_language_scanner.l"
		{
	return T_EXTENDS;
}
#line 7638 "Zend/zend_language_scanner.c"
yy825:
		YYDEBUG(825, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(826, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 871 "Zend/zend_language_scanner.l"
		{
	return T_EXIT;
}
#line 7651 "Zend/zend_language_scanner.c"
yy827:
		YYDEBUG(827, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy828;
		if (yych != 'l') goto yy186;
yy828:
		YYDEBUG(828, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(829, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1101 "Zend/zend_language_scanner.l"
		{
	return T_EVAL;
}
#line 7669 "Zend/zend_language_scanner.c"
yy830:
		YYDEBUG(830, *YYCURSOR);
		yych = *++YYCURSOR;
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'D':
		case 'd':	goto yy831;
		case 'F':
		case 'f':	goto yy832;
		case 'I':
		case 'i':	goto yy833;
		case 'S':
		case 's':	goto yy834;
		case 'W':
		case 'w':	goto yy835;
		default:	goto yy186;
		}
yy831:
		YYDEBUG(831, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy857;
		if (yych == 'e') goto yy857;
		goto yy186;
yy832:
		YYDEBUG(832, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy849;
		if (yych == 'o') goto yy849;
		goto yy186;
yy833:
		YYDEBUG(833, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy847;
		if (yych == 'f') goto yy847;
		goto yy186;
yy834:
		YYDEBUG(834, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'W') goto yy841;
		if (yych == 'w') goto yy841;
		goto yy186;
yy835:
		YYDEBUG(835, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy836;
		if (yych != 'h') goto yy186;
yy836:
		YYDEBUG(836, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy837;
		if (yych != 'i') goto yy186;
yy837:
		YYDEBUG(837, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy838;
		if (yych != 'l') goto yy186;
yy838:
		YYDEBUG(838, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy839;
		if (yych != 'e') goto yy186;
yy839:
		YYDEBUG(839, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(840, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 923 "Zend/zend_language_scanner.l"
		{
	return T_ENDWHILE;
}
#line 7743 "Zend/zend_language_scanner.c"
yy841:
		YYDEBUG(841, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy842;
		if (yych != 'i') goto yy186;
yy842:
		YYDEBUG(842, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy843;
		if (yych != 't') goto yy186;
yy843:
		YYDEBUG(843, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy844;
		if (yych != 'c') goto yy186;
yy844:
		YYDEBUG(844, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy845;
		if (yych != 'h') goto yy186;
yy845:
		YYDEBUG(845, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(846, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 967 "Zend/zend_language_scanner.l"
		{
	return T_ENDSWITCH;
}
#line 7776 "Zend/zend_language_scanner.c"
yy847:
		YYDEBUG(847, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(848, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 911 "Zend/zend_language_scanner.l"
		{
	return T_ENDIF;
}
#line 7789 "Zend/zend_language_scanner.c"
yy849:
		YYDEBUG(849, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy850;
		if (yych != 'r') goto yy186;
yy850:
		YYDEBUG(850, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '@') {
				if (yych <= '/') goto yy851;
				if (yych <= '9') goto yy185;
			} else {
				if (yych == 'E') goto yy852;
				if (yych <= 'Z') goto yy185;
			}
		} else {
			if (yych <= 'd') {
				if (yych != '`') goto yy185;
			} else {
				if (yych <= 'e') goto yy852;
				if (yych <= 'z') goto yy185;
				if (yych >= 0x7F) goto yy185;
			}
		}
yy851:
		YYDEBUG(851, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 935 "Zend/zend_language_scanner.l"
		{
	return T_ENDFOR;
}
#line 7822 "Zend/zend_language_scanner.c"
yy852:
		YYDEBUG(852, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy853;
		if (yych != 'a') goto yy186;
yy853:
		YYDEBUG(853, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy854;
		if (yych != 'c') goto yy186;
yy854:
		YYDEBUG(854, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'H') goto yy855;
		if (yych != 'h') goto yy186;
yy855:
		YYDEBUG(855, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(856, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 943 "Zend/zend_language_scanner.l"
		{
	return T_ENDFOREACH;
}
#line 7850 "Zend/zend_language_scanner.c"
yy857:
		YYDEBUG(857, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy858;
		if (yych != 'c') goto yy186;
yy858:
		YYDEBUG(858, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy859;
		if (yych != 'l') goto yy186;
yy859:
		YYDEBUG(859, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy860;
		if (yych != 'a') goto yy186;
yy860:
		YYDEBUG(860, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy861;
		if (yych != 'r') goto yy186;
yy861:
		YYDEBUG(861, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy862;
		if (yych != 'e') goto yy186;
yy862:
		YYDEBUG(862, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(863, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 951 "Zend/zend_language_scanner.l"
		{
	return T_ENDDECLARE;
}
#line 7888 "Zend/zend_language_scanner.c"
yy864:
		YYDEBUG(864, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy865;
		if (yych != 't') goto yy186;
yy865:
		YYDEBUG(865, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy866;
		if (yych != 'y') goto yy186;
yy866:
		YYDEBUG(866, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(867, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1141 "Zend/zend_language_scanner.l"
		{
	return T_EMPTY;
}
#line 7911 "Zend/zend_language_scanner.c"
yy868:
		YYDEBUG(868, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy869;
		if (yych != 'e') goto yy186;
yy869:
		YYDEBUG(869, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '^') {
			if (yych <= '@') {
				if (yych <= '/') goto yy870;
				if (yych <= '9') goto yy185;
			} else {
				if (yych == 'I') goto yy871;
				if (yych <= 'Z') goto yy185;
			}
		} else {
			if (yych <= 'h') {
				if (yych != '`') goto yy185;
			} else {
				if (yych <= 'i') goto yy871;
				if (yych <= 'z') goto yy185;
				if (yych >= 0x7F) goto yy185;
			}
		}
yy870:
		YYDEBUG(870, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 915 "Zend/zend_language_scanner.l"
		{
	return T_ELSE;
}
#line 7944 "Zend/zend_language_scanner.c"
yy871:
		YYDEBUG(871, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'F') goto yy872;
		if (yych != 'f') goto yy186;
yy872:
		YYDEBUG(872, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(873, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 907 "Zend/zend_language_scanner.l"
		{
	return T_ELSEIF;
}
#line 7962 "Zend/zend_language_scanner.c"
yy874:
		YYDEBUG(874, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy875;
		if (yych != 'o') goto yy186;
yy875:
		YYDEBUG(875, *YYCURSOR);
		++YYCURSOR;
		if (yybm[0+(yych = *YYCURSOR)] & 4) {
			goto yy185;
		}
		YYDEBUG(876, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 991 "Zend/zend_language_scanner.l"
		{
	return T_ECHO;
}
#line 7980 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_PROPERTY:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128,   0,   0, 128,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,   0,   0,   0,   0,   0,   0, 
			  0,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,   0,   0,   0,   0,  64, 
			  0,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,   0,   0,   0,   0,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
		};
		YYDEBUG(877, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '-') {
			if (yych <= '\r') {
				if (yych <= 0x08) goto yy885;
				if (yych <= '\n') goto yy879;
				if (yych <= '\f') goto yy885;
			} else {
				if (yych == ' ') goto yy879;
				if (yych <= ',') goto yy885;
				goto yy881;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '@') goto yy885;
				if (yych <= 'Z') goto yy883;
				if (yych <= '^') goto yy885;
				goto yy883;
			} else {
				if (yych <= '`') goto yy885;
				if (yych <= 'z') goto yy883;
				if (yych <= '~') goto yy885;
				goto yy883;
			}
		}
yy879:
		YYDEBUG(879, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy891;
yy880:
		YYDEBUG(880, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1024 "Zend/zend_language_scanner.l"
		{
	zendlval->value.str.val = yytext; /* no copying - intentional */
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	HANDLE_NEWLINES(yytext, yyleng);
	return T_WHITESPACE;
}
#line 8061 "Zend/zend_language_scanner.c"
yy881:
		YYDEBUG(881, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '>') goto yy888;
yy882:
		YYDEBUG(882, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1043 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	yy_pop_state(TSRMLS_C);
	goto restart;
}
#line 8075 "Zend/zend_language_scanner.c"
yy883:
		YYDEBUG(883, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy887;
yy884:
		YYDEBUG(884, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1036 "Zend/zend_language_scanner.l"
		{
	yy_pop_state(TSRMLS_C);
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	return T_STRING;
}
#line 8091 "Zend/zend_language_scanner.c"
yy885:
		YYDEBUG(885, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy882;
yy886:
		YYDEBUG(886, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy887:
		YYDEBUG(887, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy886;
		}
		goto yy884;
yy888:
		YYDEBUG(888, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(889, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1032 "Zend/zend_language_scanner.l"
		{
	return T_OBJECT_OPERATOR;
}
#line 8116 "Zend/zend_language_scanner.c"
yy890:
		YYDEBUG(890, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy891:
		YYDEBUG(891, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy890;
		}
		goto yy880;
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_VARNAME:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(892, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy896;
			if (yych <= 'Z') goto yy894;
			if (yych <= '^') goto yy896;
		} else {
			if (yych <= '`') goto yy896;
			if (yych <= 'z') goto yy894;
			if (yych <= '~') goto yy896;
		}
yy894:
		YYDEBUG(894, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy899;
yy895:
		YYDEBUG(895, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1375 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	yy_pop_state(TSRMLS_C);
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	return T_STRING_VARNAME;
}
#line 8194 "Zend/zend_language_scanner.c"
yy896:
		YYDEBUG(896, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(897, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1384 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	yy_pop_state(TSRMLS_C);
	yy_push_state(ST_IN_SCRIPTING TSRMLS_CC);
	goto restart;
}
#line 8207 "Zend/zend_language_scanner.c"
yy898:
		YYDEBUG(898, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy899:
		YYDEBUG(899, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy898;
		}
		goto yy895;
	}
/* *********************************** */
yyc_ST_NOWDOC:
	YYDEBUG(900, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	YYDEBUG(902, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(903, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2218 "Zend/zend_language_scanner.l"
	{
	int newline = 0;

	if (YYCURSOR > YYLIMIT) {
		return 0;
	}

	YYCURSOR--;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
				if (*YYCURSOR == '\n') {
					YYCURSOR++;
				}
				/* fall through */
			case '\n':
				/* Check for ending label on the next line */
				if (IS_LABEL_START(*YYCURSOR) && CG(heredoc_len) < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, CG(heredoc), CG(heredoc_len))) {
					YYCTYPE *end = YYCURSOR + CG(heredoc_len);

					if (*end == ';') {
						end++;
					}

					if (*end == '\n' || *end == '\r') {
						/* newline before label will be subtracted from returned text, but
						 * yyleng/yytext will include it, for zend_highlight/strip, tokenizer, etc. */
						if (YYCURSOR[-2] == '\r' && YYCURSOR[-1] == '\n') {
							newline = 2; /* Windows newline */
						} else {
							newline = 1;
						}

						CG(increment_lineno) = 1; /* For newline before label */
						BEGIN(ST_END_HEREDOC);

						goto nowdoc_scan_done;
					}
				}
				/* fall through */
			default:
				continue;
		}
	}

nowdoc_scan_done:
	yyleng = YYCURSOR - SCNG(yy_text);

	zend_copy_value(zendlval, yytext, yyleng - newline);
	zendlval->type = IS_STRING;
	HANDLE_NEWLINES(yytext, yyleng - newline);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 8284 "Zend/zend_language_scanner.c"
/* *********************************** */
yyc_ST_VAR_OFFSET:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			224, 224, 224, 224, 224, 224, 224, 224, 
			224, 224,   0,   0,   0,   0,   0,   0, 
			  0, 160, 160, 160, 160, 160, 160,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,   0,   0,   0,   0,  32, 
			  0, 160, 160, 160, 160, 160, 160,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,   0,   0,   0,   0,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
			 32,  32,  32,  32,  32,  32,  32,  32, 
		};
		YYDEBUG(904, *YYCURSOR);
		YYFILL(3);
		yych = *YYCURSOR;
		if (yych <= '/') {
			if (yych <= ' ') {
				if (yych <= '\f') {
					if (yych <= 0x08) goto yy918;
					if (yych <= '\n') goto yy914;
					goto yy918;
				} else {
					if (yych <= '\r') goto yy914;
					if (yych <= 0x1F) goto yy918;
					goto yy914;
				}
			} else {
				if (yych <= '$') {
					if (yych <= '"') goto yy913;
					if (yych <= '#') goto yy914;
					goto yy909;
				} else {
					if (yych == '\'') goto yy914;
					goto yy913;
				}
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '@') {
					if (yych <= '0') goto yy906;
					if (yych <= '9') goto yy908;
					goto yy913;
				} else {
					if (yych <= 'Z') goto yy916;
					if (yych <= '[') goto yy913;
					goto yy914;
				}
			} else {
				if (yych <= '_') {
					if (yych <= ']') goto yy911;
					if (yych <= '^') goto yy913;
					goto yy916;
				} else {
					if (yych <= '`') goto yy913;
					if (yych <= 'z') goto yy916;
					if (yych <= '~') goto yy913;
					goto yy916;
				}
			}
		}
yy906:
		YYDEBUG(906, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'W') {
			if (yych <= '/') goto yy907;
			if (yych <= '9') goto yy929;
		} else {
			if (yych <= 'X') goto yy927;
			if (yych == 'x') goto yy927;
		}
yy907:
		YYDEBUG(907, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1434 "Zend/zend_language_scanner.l"
		{ /* Offset could be treated as a long */
	if (yyleng < MAX_LENGTH_OF_LONG - 1 || (yyleng == MAX_LENGTH_OF_LONG - 1 && strcmp(yytext, long_min_digits) < 0)) {
		zendlval->value.lval = strtol(yytext, NULL, 10);
		zendlval->type = IS_LONG;
	} else {
		zendlval->value.str.val = (char *)estrndup(yytext, yyleng);
		zendlval->value.str.len = yyleng;
		zendlval->type = IS_STRING;
	}
	return T_NUM_STRING;
}
#line 8396 "Zend/zend_language_scanner.c"
yy908:
		YYDEBUG(908, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy926;
yy909:
		YYDEBUG(909, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy910;
			if (yych <= 'Z') goto yy922;
			if (yych >= '_') goto yy922;
		} else {
			if (yych <= '`') goto yy910;
			if (yych <= 'z') goto yy922;
			if (yych >= 0x7F) goto yy922;
		}
yy910:
		YYDEBUG(910, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1744 "Zend/zend_language_scanner.l"
		{
	/* Only '[' can be valid, but returning other tokens will allow a more explicit parse error */
	return yytext[0];
}
#line 8421 "Zend/zend_language_scanner.c"
yy911:
		YYDEBUG(911, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(912, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1739 "Zend/zend_language_scanner.l"
		{
	yy_pop_state(TSRMLS_C);
	return ']';
}
#line 8432 "Zend/zend_language_scanner.c"
yy913:
		YYDEBUG(913, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy910;
yy914:
		YYDEBUG(914, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(915, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1749 "Zend/zend_language_scanner.l"
		{
	/* Invalid rule to return a more explicit parse error with proper line number */
	yyless(0);
	yy_pop_state(TSRMLS_C);
	return T_ENCAPSED_AND_WHITESPACE;
}
#line 8449 "Zend/zend_language_scanner.c"
yy916:
		YYDEBUG(916, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy921;
yy917:
		YYDEBUG(917, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1756 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, yytext, yyleng);
	zendlval->type = IS_STRING;
	return T_STRING;
}
#line 8464 "Zend/zend_language_scanner.c"
yy918:
		YYDEBUG(918, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(919, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2274 "Zend/zend_language_scanner.l"
		{
	if (YYCURSOR > YYLIMIT) {
		return 0;
	}

	zend_error(E_COMPILE_WARNING,"Unexpected character in input:  '%c' (ASCII=%d) state=%d", yytext[0], yytext[0], YYSTATE);
	goto restart;
}
#line 8479 "Zend/zend_language_scanner.c"
yy920:
		YYDEBUG(920, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy921:
		YYDEBUG(921, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy920;
		}
		goto yy917;
yy922:
		YYDEBUG(922, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(923, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy922;
			} else {
				if (yych <= '@') goto yy924;
				if (yych <= 'Z') goto yy922;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy922;
			} else {
				if (yych <= 'z') goto yy922;
				if (yych >= 0x7F) goto yy922;
			}
		}
yy924:
		YYDEBUG(924, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1733 "Zend/zend_language_scanner.l"
		{
	zend_copy_value(zendlval, (yytext+1), (yyleng-1));
	zendlval->type = IS_STRING;
	return T_VARIABLE;
}
#line 8521 "Zend/zend_language_scanner.c"
yy925:
		YYDEBUG(925, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy926:
		YYDEBUG(926, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy925;
		}
		goto yy907;
yy927:
		YYDEBUG(927, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy932;
		}
		YYDEBUG(928, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy907;
yy929:
		YYDEBUG(929, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(930, *YYCURSOR);
		if (yych <= '/') goto yy931;
		if (yych <= '9') goto yy929;
yy931:
		YYDEBUG(931, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1446 "Zend/zend_language_scanner.l"
		{ /* Offset must be treated as a string */
	zendlval->value.str.val = (char *)estrndup(yytext, yyleng);
	zendlval->value.str.len = yyleng;
	zendlval->type = IS_STRING;
	return T_NUM_STRING;
}
#line 8560 "Zend/zend_language_scanner.c"
yy932:
		YYDEBUG(932, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(933, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy932;
		}
		goto yy931;
	}
}
#line 2283 "Zend/zend_language_scanner.l"

}
